{------------------------------------------------------------------------------}
{        (C) 1997 - 2014 Aktiv Co. All rights reserved.                        }
{ Write mask example using Guardant API Borland Delphi  (32-64 bit)            }
{------------------------------------------------------------------------------}
{ This example demonstrates Guardant API usage for writing dongles.            }
{         This code sample is for API demonstration only!                      }
{          Please do not use this code in real projects!                       }
{------------------------------------------------------------------------------}
{$REGION 'Documentation'}
/// <summary>
///       .
/// </summary>
{$ENDREGION}
unit grdAbstractDescriptor;

interface

uses System.SysUtils, GrdStructures, GrdError, GrdDelphi;

type

  {$REGION 'Documentation'}
  /// <summary>
  ///      .
  /// </summary>
  {$ENDREGION}
  TAbstractDescriptor = class(TObject)
  private
    {$REGION 'Documentation'}
    /// <summary>
    ///   ,    ,    .
    /// </summary>
    {$ENDREGION}
    FDescriptorType:  TDescriptorType;   // ,   
    {$REGION 'Documentation'}
    /// <summary>
    ///   ,     rs_algo_XXXX.
    /// </summary>
    {$ENDREGION}
    Frs_algo:         Byte;              //    rs_algo_XXXX
    {$REGION 'Documentation'}
    /// <summary>
    ///          .
    /// </summary>
    {$ENDREGION}
    function GetSize: Integer;
    {$REGION 'Documentation'}
    /// <summary>
    ///       .
    /// </summary>
    {$ENDREGION}
    function Get_rs_Algo: TRsAlgo;
  protected
    {$REGION 'Documentation'}
    /// <summary>
    ///          
    ///   .
    /// </summary>
    {$ENDREGION}
    FDescriptorBuffer:  array of Byte; //    
    {$REGION 'Documentation'}
    /// <summary>
    ///        rs_LoFlalgs.   <br />
    ///     ,   <br />
    ///   .
    /// </summary>
    /// <param name="Value">
    ///    True -  , False -  .
    /// </param>
    /// <param name="LoFlag">
    ///    .   nsafl_xx  TLoFlags.
    /// </param>
    /// <param name="Ars_LoFlag">
    ///      Frs_LoFlags,   .
    /// </param>
    /// <example>
    ///   //     <br /><br /><c>Set_LoFlags(True,
    ///   nsafl_ActivationSrv, Frs_LoFlags);</c>
    /// </example>
    {$ENDREGION}
    procedure Set_LoFlags(const Value: Boolean; LoFlag: TLoFlags; var Ars_LoFlag: Byte);
    {$REGION 'Documentation'}
    /// <summary>
    ///         
    ///   .  True,     False,  
    ///    .
    /// </summary>
    /// <param name="AFlag">
    ///    .   nsafl_xx  TLoFlags.
    /// </param>
    /// <param name="Ars_LoFlag">
    ///      Frs_LoFlags,   .
    /// </param>
    /// <returns>
    ///   True,   ; False,    .
    /// </returns>
    /// <example>
    ///   <para>
    ///     //    
    ///   </para>
    ///   <para>
    ///     <c>Result:= Get_LoFlags(nsafl_ActivationSrv, Frs_LoFlags);</c><br />
    ///   </para>
    /// </example>
    {$ENDREGION}
    function Get_LoFlags(LoFlag: TLoFlags; var Ars_LoFlag: Byte): Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       , 
    ///     .  True,    
    ///   False,    .
    /// </summary>
    /// <param name="HiFlag">
    ///    .   nsafh_xx  THiFlags.
    /// </param>
    /// <param name="Ars_HiFlag">
    ///      Frs_HiFlags,   .
    /// </param>
    /// <returns>
    ///   True,   ; False,    .
    /// </returns>
    {$ENDREGION}
    function Get_HiFlags(HiFlag: THiFlags; var Ars_HiFlag: Word): Boolean; overload;
    {$REGION 'Documentation'}
    /// <summary>
    ///       , 
    ///     .  True,    
    ///   False,    .
    /// </summary>
    /// <param name="HiFlag">
    ///    .   nsafh_xx  THiFlags.
    /// </param>
    /// <param name="Ars_HiFlag">
    ///      Frs_HiFlags,   .
    /// </param>
    /// <returns>
    ///   True,   ; False,    .
    /// </returns>
    {$ENDREGION}
    function Get_HiFlags(HiFlag: THiFlags; var Ars_HiFlag: LongWord): Boolean; overload;
    {$REGION 'Documentation'}
    /// <summary>
    ///        rs_HiFlalgs.   <br />
    ///      ,  
    ///    .
    /// </summary>
    /// <param name="Value">
    ///    True -  , False -  .
    /// </param>
    /// <param name="HiFlag">
    ///    .   nsafh_xx  THiFlags.
    /// </param>
    /// <param name="Ars_HiFlag">
    ///      Frs_HiFlags,   .
    /// </param>
    {$ENDREGION}
    procedure Set_HiFlags(const Value: Boolean; HiFlag: THiFlags; var Ars_HiFlag: Word); overload;
    {$REGION 'Documentation'}
    /// <summary>
    ///        rs_HiFlalgs.   <br />
    ///      ,  
    ///    .
    /// </summary>
    /// <param name="Value">
    ///    True -  , False -  .
    /// </param>
    /// <param name="HiFlag">
    ///    .   nsafh_xx  THiFlags.
    /// </param>
    /// <param name="Ars_HiFlag">
    ///      Frs_HiFlags,   .
    /// </param>
    {$ENDREGION}
    procedure Set_HiFlags(const Value: Boolean; HiFlag: THiFlags; var Ars_HiFlag: LongWord); overload;
    procedure CopyObject(ADescriptor: TAbstractDescriptor); virtual; abstract;
    {$REGION 'Documentation'}
    /// <summary>
    ///         Frs_algo.
    /// </summary>
    {$ENDREGION}
    procedure Set_rs_Algo(const Value: TRsAlgo);
  public
    // Constructor and Destructor
    constructor Create();
    // properties
    {$REGION 'Documentation'}
    /// <summary>
    ///   ,     
    ///      Guardant.
    /// </summary>
    /// <value>
    ///     TDescriptorType: dtStealthII, dtStealthIII, dtSign
    /// </value>
    {$ENDREGION}
    property DescriptorType: TDescriptorType read FDescriptorType write FDescriptorType;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  ".
    /// </summary>
    /// <value>
    ///     TAlgo: rs_algo_Stealth, rs_algo_GSII64 ... rs_algo_xxx
    /// </value>
    /// <remarks>
    ///     .
    /// </remarks>
    {$ENDREGION}
    property Algo: TRsAlgo read Get_rs_Algo;// write Set_rs_Algo;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "     
    ///   ".
    /// </summary>
    /// <value>
    ///     .
    /// </value>
    {$ENDREGION}
    property Size: Integer read GetSize;
    // Virtual
    {$REGION 'Documentation'}
    /// <summary>
    ///         
    ///   .
    /// </summary>
    /// <param name="ADump">
    ///     TDump (array of Byte <c>)</c>,   
    ///     .
    /// </param>
    {$ENDREGION}
    procedure GetDump(var ADump: TDump); virtual;
  end;

implementation

{$REGION 'TDescriptor'}

{TDescriptor}

constructor TAbstractDescriptor.Create;
begin
  inherited Create();
  //   
  Frs_algo:= 0;
end;

procedure TAbstractDescriptor.GetDump(var ADump: TDump);
begin
  SetLength(ADump, Length(FDescriptorBuffer));
  Move(FDescriptorBuffer[0], ADump[0], Length(FDescriptorBuffer));
end;

function TAbstractDescriptor.GetSize: Integer;
begin
  Result:= Length(FDescriptorBuffer);
end;

function TAbstractDescriptor.Get_HiFlags(HiFlag: THiFlags; var Ars_HiFlag: Word): Boolean;
begin
  Result:= (Ars_HiFlag and Word(HiFlag)) = Word(HiFlag);
end;

function TAbstractDescriptor.Get_HiFlags(HiFlag: THiFlags; var Ars_HiFlag: LongWord): Boolean;
begin
  Result:= (Ars_HiFlag and LongWord(HiFlag)) = LongWord(HiFlag);
end;

function TAbstractDescriptor.Get_LoFlags(LoFlag: TLoFlags; var Ars_LoFlag: Byte): Boolean;
begin
  Result:= (Ars_LoFlag and Byte(LoFlag)) = Byte(LoFlag);
end;

procedure TAbstractDescriptor.Set_LoFlags(const Value: Boolean; LoFlag: TLoFlags; var Ars_LoFlag: Byte);
begin
  if Value = True then
    //  
    Ars_LoFlag:= Ars_LoFlag or Byte(LoFlag)
  else
  begin
    //  
    Ars_LoFlag:= Ars_LoFlag and (not Byte(LoFlag));
  end;
end;

procedure TAbstractDescriptor.Set_HiFlags(const Value: Boolean; HiFlag: THiFlags; var Ars_HiFlag: Word);
begin
  if Value = True then
    //  
    Ars_HiFlag:= Ars_HiFlag or Word(HiFlag)
  else
  begin
    //  
    Ars_HiFlag:= Ars_HiFlag and (not Word(HiFlag));
  end;
end;

procedure TAbstractDescriptor.Set_HiFlags(const Value: Boolean; HiFlag: THiFlags; var Ars_HiFlag: LongWord);
begin
  if Value = True then
    //  
    Ars_HiFlag:= Ars_HiFlag or LongWord(HiFlag)
  else
  begin
    //  
    Ars_HiFlag:= Ars_HiFlag and (not LongWord(HiFlag));
  end;
end;

function TAbstractDescriptor.Get_rs_Algo: TRsAlgo;
begin
  Result:= TRsAlgo(Frs_algo);
end;

procedure TAbstractDescriptor.Set_rs_Algo(const Value: TRsAlgo);
begin
  Frs_algo:= Byte(Value);
end;

{$ENDREGION}

end.
