{------------------------------------------------------------------------------}
{        (C) 1997 - 2014 Aktiv Co. All rights reserved.                        }
{ Write mask example using Guardant API Borland Delphi  (32-64 bit)            }
{------------------------------------------------------------------------------}
{ This example demonstrates Guardant API usage for writing dongles.            }
{         This code sample is for API demonstration only!                      }
{          Please do not use this code in real projects!                       }
{------------------------------------------------------------------------------}
{$REGION 'Documentation'}
/// <summary>
///          
///     Guardant Sign, Sign Net, Time, Time Net, Code, Code
///   Time, SP, SP Net.
/// </summary>
{$ENDREGION}
unit grdDescriptor;

interface

uses System.SysUtils, grdAbstractDescriptor, GrdStructures, GrdError, GrdDelphi;

type

  {$REGION 'Documentation'}
  /// <summary>
  ///          
  ///    Guardant Sign, Sign Net, Time, Time Net, Code, Code Time, SP, SP
  ///   Net.
  /// </summary>
  /// <example>
  ///   <note type="delphi">
  ///     <c>GsII64D:= TSign.Create(atGSII64);</c><br /><c>
  ///     GsII64D.SetDeterminant(GSII64_DEMO_D);</c><br /><c>
  ///     GsII64D.ActivatePwd:= GrdAP_GSII64_DEMO_ACTIVATION;</c><br /><c>
  ///     GsII64D.DeactivatePwd:= GrdAP_GSII64_DEMO_DEACTIVATION;</c><br /><c>
  ///     GsII64D.ReadPwd:= GrdAP_GSII64_DEMO_READ;</c><br /><c>
  ///     GsII64D.UpdatePwd:= GrdAP_GSII64_DEMO_UPDATE;</c><br /><c>
  ///     GsII64D.ErrorCounter:= 10;</c>
  ///   </note>
  /// </example>
  {$ENDREGION}
  TDescriptor = class(TAbstractDescriptor)
  private
    {$REGION 'Documentation'}
    /// <summary>
    ///      nsafl_xxx.
    /// </summary>
    {$ENDREGION}
    Frs_LoFlags:      Byte;                 //    nsafl_xxx
    //Frs_algo:       Byte;                 //   TDescriptor
    {$REGION 'Documentation'}
    /// <summary>
    ///     nsafh_xxx.
    /// </summary>
    {$ENDREGION}
    Frs_HiFlags:      LongWord;             //   nsafh_xxx
    {$REGION 'Documentation'}
    /// <summary>
    ///           (rs_K[]).
    /// </summary>
    {$ENDREGION}
    Frs_klen:         LongWord;             //         (rs_K[])
    {$REGION 'Documentation'}
    /// <summary>
    ///        .
    /// </summary>
    {$ENDREGION}
    Frs_blen:         LongWord;             //      
    {$REGION 'Documentation'}
    /// <summary>
    ///     (   nsafl_ActivationSrv).
    /// </summary>
    {$ENDREGION}
    Frs_ActivatePwd:  LongWord;             //   (   nsafl_ActivationSrv)
    {$REGION 'Documentation'}
    /// <summary>
    ///     (   nsafl_DeactivationSrv).
    /// </summary>
    {$ENDREGION}
    Frs_DeactivatePwd:LongWord;             //   (   nsafl_DeactivationSrv)
    {$REGION 'Documentation'}
    /// <summary>
    ///       rs_GP,rs_ErrorCounter, rs_K[]( 
    ///    nsafh_ReadPwd).
    /// </summary>
    {$ENDREGION}
    Frs_ReadPwd:      LongWord;             //     rs_GP,rs_ErrorCounter, rs_K[](   nsafh_ReadPwd)
    {$REGION 'Documentation'}
    /// <summary>
    ///       rs_GP,rs_ErrorCounter, rs_K[] (
    ///   -  nsafh_UpdateSrv).
    /// </summary>
    {$ENDREGION}
    Frs_UpdatePwd:    LongWord;             //     rs_GP,rs_ErrorCounter, rs_K[] ( -  nsafh_UpdateSrv)
    {$REGION 'Documentation'}
    /// <summary>
    ///         (  
    ///   nsafh_BirthTime).
    /// </summary>
    {$ENDREGION}
    Frs_BirthTime:    TGrdTime;             //       (   nsafh_BirthTime)
    {$REGION 'Documentation'}
    /// <summary>
    ///         (  
    ///   nsafh_DeadTime).
    /// </summary>
    {$ENDREGION}
    Frs_DeadTime:     TGrdTime;             //       (   nsafh_DeadTime)
    {$REGION 'Documentation'}
    /// <summary>
    ///   ,        (
    ///     nsafh_Lifetime).
    /// </summary>
    {$ENDREGION}
    Frs_Lifetime:     TGrdLifeTime;         // ,        (   nsafh_Lifetime)
    {$REGION 'Documentation'}
    /// <summary>
    ///      nsafh_FlipTime -    rs_DaysGap
    ///   .
    /// </summary>
    {$ENDREGION}
    Frs_FlipTime:     TGrdFlipTime;         //    nsafh_FlipTime -    rs_DaysGap 
    {$REGION 'Documentation'}
    /// <summary>
    ///      (   nsafl_GP_dec 
    ///   nsafl_GP).
    /// </summary>
    {$ENDREGION}
    Frs_GP:           LongWord;             //    (   nsafl_GP_dec  nsafl_GP).    1    .
    {$REGION 'Documentation'}
    /// <summary>
    ///       .
    /// </summary>
    {$ENDREGION}
    Frs_ErrorCounter: LongWord;             //     (      : nsafl_ActivationSrv, nsafl_DeactivationSrv, nsafl_UpdateSrv).
    // Property methods
    //function Get_rs_Algo: TAlgo;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_BirthTime.
    /// </summary>
    {$ENDREGION}
    function GetBirthTime():    TGrdTime;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_DeadTime.
    /// </summary>
    {$ENDREGION}
    function GetDeadTime():     TGrdTime;
    {$REGION 'Documentation'}
    /// <summary>
    ///       nsafh_BirthTime   Frs_Hiflags.
    /// </summary>
    /// <returns>
    ///    True,   .  False.
    /// </returns>
    {$ENDREGION}
    function Get_nsafh_BirthTime: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       nsafh_DeadTime   Frs_Hiflags.
    /// </summary>
    /// <returns>
    ///    True,   .  False.
    /// </returns>
    {$ENDREGION}
    function Get_nsafh_DeadTime: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_Lifetime.
    /// </summary>
    {$ENDREGION}
    function GetLifeTime: TGrdTime;
    {$REGION 'Documentation'}
    /// <summary>
    ///       nsafh_LifeTime   Frs_Hiflags. <br />
    /// </summary>
    /// <returns>
    ///    True,   .  False.
    /// </returns>
    {$ENDREGION}
    function Get_nsafh_LifeTime: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       nsafl_ActivationSrv  
    ///   Frs_Loflags. <br />
    /// </summary>
    /// <returns>
    ///    True,   .  False.
    /// </returns>
    {$ENDREGION}
    function Get_nsafl_ActivationSrv: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       nsafl_DeactivationSrv  
    ///   Frs_Loflags. <br />
    /// </summary>
    /// <returns>
    ///    True,   .  False.
    /// </returns>
    {$ENDREGION}
    function Get_nsafl_DeactivationSrv: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       nsafl_InactiveFlag  
    ///   Frs_LoFlags.
    /// </summary>
    /// <returns>
    ///    True,   .  False.
    /// </returns>
    {$ENDREGION}
    function Get_nsafl_InactiveFlag: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       nsafl_ST_III  Frs_LoFlags.
    /// </summary>
    /// <returns>
    ///    True,   .  False.
    /// </returns>
    {$ENDREGION}
    function Get_nsafl_ST_III: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_ErrorCounter.
    /// </summary>
    {$ENDREGION}
    function Get_rs_ErrorCounter: LongWord;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_ActivatePwd.
    /// </summary>
    {$ENDREGION}
    function Get_rs_ActivatePwd: LongWord;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_DeactivatePwd.
    /// </summary>
    {$ENDREGION}
    function Get_rs_DeactivatePwd: LongWord;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_BirthTime.
    /// </summary>
    {$ENDREGION}
    procedure SetBirthTime(const Value: TGrdTime);
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_DeadTime.
    /// </summary>
    {$ENDREGION}
    procedure SetDeadTime(const Value: TGrdTime);
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_LifeTime.
    /// </summary>
    {$ENDREGION}
    procedure SetLifeTime(const Value: TGrdTime);
    {$REGION 'Documentation'}
    /// <summary>
    ///      
    ///   Frs_FlipTime.rs_ChangeFlipTimeStart.
    /// </summary>
    {$ENDREGION}
    procedure SetFlipTime(const Value: TGrdTime);
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_FlipTime.rs_DaysGap.
    /// </summary>
    {$ENDREGION}
    procedure SetFlipTimeDays(const Value: Byte);
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_ReadPwd.
    /// </summary>
    {$ENDREGION}
    procedure Set_rs_ReadPwd(const Value: LongWord);
    {$REGION 'Documentation'}
    /// <summary>
    ///        nsafh_BirthTime  
    ///   Frs_HiFlags.
    /// </summary>
    {$ENDREGION}
    procedure Set_nsafh_BirthTime(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///        nsafh_DeadTime  
    ///   Frs_HiFlags.
    /// </summary>
    {$ENDREGION}
    procedure Set_nsafh_DeadTime(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///        nsafh_FlipTime  
    ///   Frs_HiFlags.
    /// </summary>
    {$ENDREGION}
    procedure Set_nsafh_FlipTime(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///        nsafh_LifeTime  
    ///   Frs_HiFlags.
    /// </summary>
    {$ENDREGION}
    procedure Set_nsafh_LifeTime(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///        nsafh_ReadPwd  
    ///   Frs_HiFlags.
    /// </summary>
    {$ENDREGION}
    procedure Set_nsafh_ReadPwd(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_ErrorCounter.
    /// </summary>
    {$ENDREGION}
    procedure Set_rs_ErrorCounter(const Value: LongWord);
    {$REGION 'Documentation'}
    /// <summary>
    ///        nsafl_ActivationSrv  
    ///   Frs_LoFlags.
    /// </summary>
    /// <param name="Value">
    ///    True  , False - .
    /// </param>
    {$ENDREGION}
    procedure Set_nsafl_ActivationSrv(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///        nsafl_DeactivationSrv  
    ///   Frs_LoFlags.
    /// </summary>
    /// <param name="Value">
    ///    True  , False - .
    /// </param>
    {$ENDREGION}
    procedure Set_nsafl_DeactivationSrv(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///        nsafl_GP_dec  
    ///   Frs_LoFlags.
    /// </summary>
    /// <param name="Value">
    ///    True  , False - .
    /// </param>
    {$ENDREGION}
    procedure Set_nsafl_GP_dec(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///        nsafl_InactiveFlag  
    ///   Frs_LoFlags.
    /// </summary>
    /// <param name="Value">
    ///    True  , False - .
    /// </param>
    {$ENDREGION}
    procedure Set_nsafl_InactiveFlag(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///        nsafl_UpdateSrv  
    ///   Frs_LoFlags.
    /// </summary>
    /// <param name="Value">
    ///    True  , False - .
    /// </param>
    {$ENDREGION}
    procedure Set_nsafl_UpdateSrv(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///        nsafl_ID   Frs_LoFlags.
    /// </summary>
    /// <param name="Value">
    ///    True  , False - .
    /// </param>
    {$ENDREGION}
    procedure Set_nsafl_ID(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_ActivatePwd.
    /// </summary>
    {$ENDREGION}
    procedure Set_rs_ActivatePwd(const Value: LongWord);
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_DeactivatePwd. <br />
    /// </summary>
    {$ENDREGION}
    procedure Set_rs_DeactivatePwd(const Value: LongWord);
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_GP.
    /// </summary>
    {$ENDREGION}
    procedure Set_rs_GP(const Value: LongWord);
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_UpdatePwd.
    /// </summary>
    {$ENDREGION}
    procedure Set_rs_UpdatePwd(const Value: LongWord);
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_Blen.
    /// </summary>
    {$ENDREGION}
    procedure Set_rs_Blen(const Value: LongWord);
    //  
    {$REGION 'Documentation'}
    /// <summary>
    ///         TGrdTime.
    /// </summary>
    {$ENDREGION}
    procedure SetNullTime(var ATime: TGrdTime);
  protected
    {$REGION 'Documentation'}
    /// <summary>
    ///          rs_klen.
    /// </summary>
    {$ENDREGION}
    Frs_K: array of Byte;        //        rs_klen.
    //  ,       " "
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_Klen.
    /// </summary>
    {$ENDREGION}
    function Get_rs_Klen: LongWord;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_Blen.
    /// </summary>
    {$ENDREGION}
    function Get_rs_Blen: LongWord;
    {$REGION 'Documentation'}
    /// <summary>
    ///       nsafl_ID   Frs_Loflags.
    /// </summary>
    /// <returns>
    ///    True,   .  False.
    /// </returns>
    {$ENDREGION}
    function Get_nsafl_ID: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_GP.
    /// </summary>
    {$ENDREGION}
    function Get_rs_GP: LongWord;
    {$REGION 'Documentation'}
    /// <summary>
    ///       nsafl_GP_dec   Frs_Loflags. <br />
    /// </summary>
    /// <returns>
    ///    True,   .  False.
    /// </returns>
    {$ENDREGION}
    function Get_nsafl_GP_dec: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       nsafh_ReadSrv   Frs_Hiflags.
    /// </summary>
    /// <returns>
    ///    True,   .  False.
    /// </returns>
    {$ENDREGION}
    function Get_nsafh_ReadSrv: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       nsafh_ReadPwd   Frs_Hiflags.
    /// </summary>
    /// <returns>
    ///    True,   .  False.
    /// </returns>
    {$ENDREGION}
    function Get_nsafh_ReadPwd: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_ReadPwd.
    /// </summary>
    {$ENDREGION}
    function Get_rs_ReadPwd: LongWord;
    {$REGION 'Documentation'}
    /// <summary>
    ///       nsafl_UpdateSrv   Frs_Loflags.
    /// </summary>
    /// <returns>
    ///    True,   .  False.
    /// </returns>
    {$ENDREGION}
    function Get_nsafl_UpdateSrv: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_UpdatePwd.
    /// </summary>
    {$ENDREGION}
    function Get_rs_UpdatePwd: LongWord;
    {$REGION 'Documentation'}
    /// <summary>
    ///       nsafh_FlipTime   Frs_Hiflags.
    /// </summary>
    /// <returns>
    ///    True,   .  False.
    /// </returns>
    {$ENDREGION}
    function Get_nsafh_FlipTime: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_FlipTime.
    /// </summary>
    {$ENDREGION}
    function GetFlipTime: TGrdTime;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_FlipTime.
    /// </summary>
    {$ENDREGION}
    function GetFlipTimeDays: Byte;
    {$REGION 'Documentation'}
    /// <summary>
    ///       Frs_Klen.
    /// </summary>
    {$ENDREGION}
    procedure Set_rs_Klen(const Value: LongWord);
    {$REGION 'Documentation'}
    /// <summary>
    ///        nsafh_ReadSrv  
    ///   Frs_HiFlags.
    /// </summary>
    /// <param name="Value">
    ///    True  , False - .
    /// </param>
    {$ENDREGION}
    procedure Set_nsafh_ReadSrv(const Value: Boolean);
  public
    // Constructor Destructor
    {$REGION 'Documentation'}
    /// <summary>
    ///        .
    /// </summary>
    /// <param name="Algorithm">
    ///         .
    /// </param>
    {$ENDREGION}
    constructor Create(Algorithm: TAlgoType); overload;
    // properties
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    ". 
    ///     rs_klen.
    /// </summary>
    /// <value>
    ///          .
    /// </value>
    /// <remarks>
    ///          
    ///       rs_K[]  ,  
    ///    .
    /// </remarks>
    {$ENDREGION}
    property Klen:            LongWord read Get_rs_Klen write Set_rs_Klen;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "     ". 
    ///     rs_blen.
    /// </summary>
    /// <value>
    ///         .
    /// </value>
    {$ENDREGION}
    property Blen:            LongWord read Get_rs_Blen write Set_rs_Blen;
    //    rs_LoFlags
    {$REGION 'Documentation'}
    /// <summary>
    ///    "   ID ".  
    ///    nsafl_ID   rs_LoFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    /// <remarks>
    ///          
    ///    -.     (AES128 
    ///   GSII64),     .
    /// </remarks>
    {$ENDREGION}
    property DependsOnId:     Boolean read Get_nsafl_ID write Set_nsafl_ID;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  GP     ".
    ///      nsafl_GP_dec   rs_LoFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    /// <remarks>
    ///     SHA256  .
    /// </remarks>
    {$ENDREGION}
    property GP_Decrease:     Boolean read Get_nsafl_GP_dec write Set_nsafl_GP_dec;
    {$REGION 'Documentation'}
    /// <summary>
    ///    " ".    rs_GP. <br />
    /// </summary>
    /// <value>
    ///     .  65535.
    /// </value>
    /// <remarks>
    ///       GP_Decrease  GP.
    /// </remarks>
    {$ENDREGION}
    property GP_Counter:      LongWord read Get_rs_GP write Set_rs_GP;
    {$REGION 'Documentation'}
    /// <summary>
    ///       "  ". 
    ///     nsafl_ST_III   rs_LoFlags.  
    ///   Sign, Stealth  .
    /// </summary>
    /// <value>
    ///     True.   .
    /// </value>
    {$ENDREGION}
    property ST_III:          Boolean read Get_nsafl_ST_III;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  ".   
    ///   nsafl_ActivationSrv   rs_LoFlags. <br />
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property ActivateSrv:     Boolean read Get_nsafl_ActivationSrv write Set_nsafl_ActivationSrv;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  ".   
    ///   rs_ActivatePwd.
    /// </summary>
    /// <value>
    ///     .   High (LongWord).
    /// </value>
    /// <remarks>
    ///         
    ///   ActivateSrv:= True.
    /// </remarks>
    {$ENDREGION}
    property ActivatePwd:     LongWord read Get_rs_ActivatePwd write Set_rs_ActivatePwd;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  ".   
    ///   nsafl_DeactivationSrv  <br /> rs_LoFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property DeactivateSrv:   Boolean read Get_nsafl_DeactivationSrv write Set_nsafl_DeactivationSrv;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  ".   
    ///   rs_DeactivatePwd.
    /// </summary>
    /// <value>
    ///     .   High (LongWord).
    /// </value>
    /// <remarks>
    ///         
    ///   DeactivateSrv:= True.
    /// </remarks>
    {$ENDREGION}
    property DeactivatePwd:   LongWord read Get_rs_DeactivatePwd write Set_rs_DeactivatePwd;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "   rs_K[]".   
    ///   nsafl_UpdateSrv   rs_LoFlags. <br />
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property UpdateSrv:       Boolean read Get_nsafl_UpdateSrv write Set_nsafl_UpdateSrv;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    rs_GP, rs_ErrorCounter, rs_K[]
    ///   ".    rs_UpdatePwd.
    /// </summary>
    /// <value>
    ///        .   High
    ///   (LongWord).
    /// </value>
    /// <remarks>
    ///         
    ///   UpdateSrv:= True.
    /// </remarks>
    {$ENDREGION}
    property UpdatePwd:       LongWord read Get_rs_UpdatePwd write Set_rs_UpdatePwd;
    {$REGION 'Documentation'}
    /// <summary>
    ///    " ".   
    ///   nsafl_InactiveFlag   rs_LoFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property InactiveFlag:    Boolean read Get_nsafl_InactiveFlag write Set_nsafl_InactiveFlag;
    //    rs_HiFlags
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    rs_K[] ".  
    ///    nsafh_ReadSrv   rs_HiFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property ReadSrv:         Boolean read Get_nsafh_ReadSrv write Set_nsafh_ReadSrv;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "     ". 
    ///     nsafh_ReadPwd   rs_HiFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property ReadByPwd:       Boolean read Get_nsafh_ReadPwd write Set_nsafh_ReadPwd;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    rs_GP, rs_ErrorCounter, rs_K[] ".
    ///      rs_ReadPwd.
    /// </summary>
    /// <value>
    ///        .   High
    ///   (LongWord).
    /// </value>
    /// <remarks>
    ///         
    ///   ReadSrv:= True  ReadByPwd:= True.
    /// </remarks>
    {$ENDREGION}
    property ReadPwd:         LongWord read Get_rs_ReadPwd write Set_rs_ReadPwd;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    ".  
    ///    nsafh_BirthTime   rs_HiFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property BirthTimeSrv:    Boolean read Get_nsafh_BirthTime write Set_nsafh_BirthTime;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    ".  
    ///    rs_BirthTime. <br />
    /// </summary>
    /// <value>
    ///          TGrdTime.
    /// </value>
    /// <remarks>
    ///        
    ///     BirthTimeSrv:= True;
    /// </remarks>
    {$ENDREGION}
    property BirthTime:       TGrdTime read GetBirthTime write SetBirthTime;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    ".  
    ///    nsafh_DeadTime   rs_HiFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property DeadTimeSrv:     Boolean read Get_nsafh_DeadTime write Set_nsafh_DeadTime;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    ". 
    ///     rs_DeadTime.
    /// </summary>
    /// <value>
    ///          TGrdTime.
    /// </value>
    /// <remarks>
    ///        
    ///     DeadTimeSrv:= True;
    /// </remarks>
    {$ENDREGION}
    property DeadTime:        TGrdTime read GetDeadTime write SetDeadTime;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    ". 
    ///     nsafh_LifeTime   rs_HiFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    /// <remarks>
    ///       DeadTimeSrv  BirthTimeSrv 
    ///   .
    /// </remarks>
    {$ENDREGION}
    property LifeTimeSrv:     Boolean read Get_nsafh_LifeTime write Set_nsafh_LifeTime;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  ".   
    ///   rs_Lifetime.
    /// </summary>
    /// <value>
    ///          TGrdTime.
    /// </value>
    /// <remarks>
    ///        
    ///     LifeTimeSrv:= True;
    /// </remarks>
    {$ENDREGION}
    property LifeTime:        TGrdTime read GetLifeTime write SetLifeTime;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "   ". 
    ///     nsafh_FlipTime   rs_HiFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    /// <remarks>
    ///          (AES128
    ///    GSII64).
    /// </remarks>
    {$ENDREGION}
    property FlipTimeSrv:     Boolean read Get_nsafh_FlipTime write Set_nsafh_FlipTime;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "   ".  
    ///    rs_FlipTime.
    /// </summary>
    /// <value>
    ///          TGrdTime.
    /// </value>
    {$ENDREGION}
    property FlipTime:        TGrdTime read GetFlipTime write SetFlipTime;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  ".   
    ///   rs_FlipTime.
    /// </summary>
    /// <value>
    ///     0 &lt; FlipTimeDays &lt; 256
    /// </value>
    {$ENDREGION}
    property FlipTimeDays:    Byte read GetFlipTimeDays write SetFlipTimeDays;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "   ".  
    ///    rs_ErrorCounter.
    /// </summary>
    /// <value>
    ///      .   High (LongWord).
    /// </value>
    /// <remarks>
    ///     ,       :
    ///   Activaterv, DeactivateSrv, UpdateSrv  ReadByPwd.
    /// </remarks>
    {$ENDREGION}
    property ErrorCounter:    LongWord read Get_rs_ErrorCounter write Set_rs_ErrorCounter;
    // Determinant
    {$REGION 'Documentation'}
    /// <summary>
    ///         
    ///     (  rs_K[] ) .
    /// </summary>
    /// <param name="Ars_K">
    ///          , 
    ///   rs_klen.
    /// </param>
    /// <remarks>
    ///        rs_klen  
    ///     (Length(Ars_k)).
    /// </remarks>
    {$ENDREGION}
    procedure SetDeterminant(Ars_K: array of Byte);
    // Vurtual
    {$REGION 'Documentation'}
    /// <summary>
    ///          
    ///   .
    /// </summary>
    /// <param name="ADump">
    ///     TDump (array of Byte)     
    ///   .
    /// </param>
    {$ENDREGION}
    procedure GetDump(var ADump: TDump); override;
  end;

implementation

{$REGION 'TSign'}

constructor TDescriptor.Create(Algorithm: TAlgoType);
begin
  //  
  Self.DescriptorType:= dtSign;

  //  
  Frs_LoFlags:=       0;
  //Frs_algo:=          0;
  Frs_HiFlags:=       0;
  Frs_klen:=          0;
  Frs_blen:=          0;
  Frs_ActivatePwd:=   0;
  Frs_DeactivatePwd:= 0;
  Frs_ReadPwd:=       0;
  Frs_UpdatePwd:=     0;

  Frs_BirthTime.bSeconds:=  0;
  Frs_BirthTime.bMinute:=   0;
  Frs_BirthTime.bHour:=     0;
  Frs_BirthTime.bDay:=      0;
  Frs_BirthTime.bMonth:=    0;
  Frs_BirthTime.bYear:=     0;
  Frs_DeadTime.bSeconds:=   0;
  Frs_DeadTime.bMinute:=    0;
  Frs_DeadTime.bHour:=      0;
  Frs_DeadTime.bDay:=       0;
  Frs_DeadTime.bMonth:=     0;
  Frs_DeadTime.bYear:=      0;
  Frs_Lifetime.LifeTime.bSeconds:=  0;
  Frs_Lifetime.LifeTime.bMinute:=   0;
  Frs_Lifetime.LifeTime.bHour:=     0;
  Frs_Lifetime.LifeTime.bDay:=      0;
  Frs_Lifetime.LifeTime.bMonth:=    0;
  Frs_Lifetime.LifeTime.bYear:=     0;
  Frs_Lifetime.State:=              0;
  Frs_Lifetime.ReservedForEven:=    0;
  Frs_FlipTime.rs_ChangeFlipTimeStart.bSeconds:=  0;
  Frs_FlipTime.rs_ChangeFlipTimeStart.bMinute:=   0;
  Frs_FlipTime.rs_ChangeFlipTimeStart.bHour:=     0;
  Frs_FlipTime.rs_ChangeFlipTimeStart.bDay:=      0;
  Frs_FlipTime.rs_ChangeFlipTimeStart.bMonth:=    0;
  Frs_FlipTime.rs_ChangeFlipTimeStart.bYear:=     0;
  Frs_FlipTime.rs_DaysGap:=                       0;
  Frs_FlipTime.ReservedForEven:=                  0;
  Frs_GP:= 0;
  Frs_ErrorCounter:= 0;

  //         
  case Algorithm of
    atGSII64:
    begin
      Set_rs_Algo(rs_algo_GSII64);
      Frs_klen:= 16;  //  32
      Frs_blen:= 8;   //  
    end;
    atGSII64_ENCRYPT:
    begin
      Set_rs_Algo(rs_algo_GSII64_ENCRYPT);
      Frs_klen:= 16;  //  32
      Frs_blen:= 8;   //  
    end;
    atGSII64_DECRYPT:
    begin
      Set_rs_Algo(rs_algo_GSII64_DECRYPT);
      Frs_klen:= 16;//  32
      Frs_blen:= 8; //  
    end;
    atHASH64:
    begin
      Set_rs_Algo(rs_algo_HASH64);
      Frs_klen:= 16;  //  32
      Frs_blen:= 8;   //  
    end;
    atRAND64:
    begin
      Set_rs_Algo(rs_algo_RND64);
      Frs_klen:= 16;  //  32
      Frs_blen:= 8;   //  
    end;
    atECC160:
    begin
      Set_rs_Algo(rs_algo_ECC160);
      Frs_klen:= 20;  //  
      Frs_blen:= 20;  //  
    end;
    atAES128:
    begin
      Set_rs_Algo(rs_algo_AES128);
      Frs_klen:= 16;  //  
      Frs_blen:= 16;  //  
    end;
    atAES128Encode:
    begin
      Set_rs_Algo(rs_algo_AES128Encode);
      Frs_klen:= 16;  //  
      Frs_blen:= 16;  //  
    end;
    atAES128Decode:
    begin
      Set_rs_Algo(rs_algo_AES128Decode);
      Frs_klen:= 16;  //  
      Frs_blen:= 16;  //  
    end;
    atSHA256:
    begin
      Set_rs_Algo(rs_algo_SHA256);
      Frs_klen:= 0;   //  
      Frs_blen:= 32;  //  
    end;
    atProtectedItem:
    begin
      Set_rs_Algo(rs_algo_PI);
      Frs_klen:= 8; // max SizeOf(LongWord)
      Frs_blen:= 0; //  
    end;
    atLoadableCode:
    begin
      Set_rs_Algo(rs_algo_LoadableCode);
      Frs_klen:= 8; // max SizeOf(LongWord)
      Frs_blen:= 0; //  
    end;
  else
    raise EDescriptorException.Create(DscE_InvalidAlgoFlag);
  end;

  //  nsafl_ST_III   
  Set_LoFlags(True, nsafl_ST_III, Frs_LoFlags);
end;

function TDescriptor.GetBirthTime: TGrdTime;
begin
  Result:= Frs_BirthTime;
end;

function TDescriptor.GetDeadTime: TGrdTime;
begin
  Result:= Frs_DeadTime;
end;

function TDescriptor.GetFlipTime: TGrdTime;
begin
  Result:= Frs_FlipTime.rs_ChangeFlipTimeStart;
end;

function TDescriptor.GetFlipTimeDays: Byte;
begin
  Result:= Frs_FlipTime.rs_DaysGap;
end;

function TDescriptor.GetLifeTime: TGrdTime;
begin
  Result:= Frs_Lifetime.LifeTime;
end;

function TDescriptor.Get_nsafh_BirthTime: Boolean;
begin
  Result:= Get_HiFlags(nsafh_BirthTime, Frs_HiFlags);
end;

function TDescriptor.Get_nsafh_DeadTime: Boolean;
begin
  Result:= Get_HiFlags(nsafh_DeadTime, Frs_HiFlags);
end;

function TDescriptor.Get_nsafh_FlipTime: Boolean;
begin
  Result:= Get_HiFlags(nsafh_FlipTime, Frs_HiFlags);
end;

function TDescriptor.Get_nsafh_LifeTime: Boolean;
begin
  Result:= Get_HiFlags(nsafh_LifeTime, Frs_HiFlags);
end;

function TDescriptor.Get_nsafh_ReadPwd: Boolean;
begin
  Result:= Get_HiFlags(nsafh_ReadPwd, Frs_HiFlags);
end;

function TDescriptor.Get_nsafh_ReadSrv: Boolean;
begin
  Result:= Get_HiFlags(nsafh_ReadSrv, Frs_HiFlags);
end;

function TDescriptor.Get_nsafl_ActivationSrv: Boolean;
begin
  Result:= Get_LoFlags(nsafl_ActivationSrv, Frs_LoFlags);
end;

function TDescriptor.Get_nsafl_DeactivationSrv: Boolean;
begin
  Result:= Get_LoFlags(nsafl_DeactivationSrv, Frs_LoFlags);
end;

function TDescriptor.Get_nsafl_GP_dec: Boolean;
begin
  Result:= Get_LoFlags(nsafl_GP_dec, Frs_LoFlags);
end;

function TDescriptor.Get_nsafl_InactiveFlag: Boolean;
begin
  Result:= Get_LoFlags(nsafl_InactiveFlag, Frs_LoFlags);
end;

function TDescriptor.Get_nsafl_ST_III: Boolean;
begin
  Result:= Get_LoFlags(nsafl_ST_III, Frs_LoFlags);
end;

function TDescriptor.Get_nsafl_UpdateSrv: Boolean;
begin
  Result:= Get_LoFlags(nsafl_UpdateSrv, Frs_LoFlags);
end;

function TDescriptor.Get_nsafl_ID: Boolean;
begin
  Result:= Get_LoFlags(nsafl_ID, Frs_LoFlags);
end;

function TDescriptor.Get_rs_ActivatePwd: LongWord;
begin
  Result:= Frs_ActivatePwd;
end;

function TDescriptor.Get_rs_Blen: LongWord;
begin
  Result:= Frs_blen;
end;

function TDescriptor.Get_rs_DeactivatePwd: LongWord;
begin
  Result:= Frs_DeactivatePwd;
end;

function TDescriptor.Get_rs_ErrorCounter: LongWord;
begin
  Result:= Frs_ErrorCounter;
end;

function TDescriptor.Get_rs_GP: LongWord;
begin
  Result:= Frs_GP;
end;

function TDescriptor.Get_rs_Klen: LongWord;
begin
  Result:= Frs_klen;
end;

function TDescriptor.Get_rs_ReadPwd: LongWord;
begin
  Result:= Frs_ReadPwd;
end;

function TDescriptor.Get_rs_UpdatePwd: LongWord;
begin
  Result:= Frs_UpdatePwd;
end;

procedure TDescriptor.SetBirthTime(const Value: TGrdTime);
begin
  //  
  Self.BirthTimeSrv:= True;

  //  
  Frs_BirthTime:= Value;
end;

procedure TDescriptor.SetDeadTime(const Value: TGrdTime);
begin
  //  
  Self.DeadTimeSrv:= True;

  //  
  Frs_DeadTime:= Value;
end;

procedure TDescriptor.SetFlipTime(const Value: TGrdTime);
begin
  //  
  Self.FlipTimeSrv:= True;

  //  
  Frs_FlipTime.rs_ChangeFlipTimeStart:= Value;
end;

procedure TDescriptor.SetFlipTimeDays(const Value: Byte);
begin
  //  
  Self.FlipTimeSrv:= True;

  //  
  Frs_FlipTime.rs_DaysGap:= Value;
end;

procedure TDescriptor.SetLifeTime(const Value: TGrdTime);
begin
  //  
  Self.LifeTimeSrv:= True;

  //  
  Frs_Lifetime.LifeTime:= Value;
end;

procedure TDescriptor.Set_nsafh_BirthTime(const Value: Boolean);
begin
  case Value of
    True:
    begin
      //      " "
      if (Self.Algo = rs_algo_PI) then
        raise EDescriptorException.Create(DscE_PI_Invalid_nsafh_BirthTime);

      //  ,    "  "
      if (Self.LifeTimeSrv = True) then
        raise EDescriptorException.Create(DscE_LifeTime_Already_Set);
    end;
    False:
    begin
      //   ,   BirthTime
      SetNullTime(Frs_BirthTime);
    end;
  end;

  //  
  Set_HiFlags(Value, nsafh_BirthTime, Frs_HiFlags);
end;

procedure TDescriptor.Set_nsafh_DeadTime(const Value: Boolean);
begin
  case Value of
    True:
    begin
      //      " "
      if (Self.Algo = rs_algo_PI) then
        raise EDescriptorException.Create(DscE_PI_Invalid_nsafh_DeadTime);

      //  ,    "  "
      if (Self.LifeTimeSrv = True) then
        raise EDescriptorException.Create(DscE_LifeTime_Already_Set);
    end;
    False:
    begin
      //   ,   DeadTime
      SetNullTime(Frs_DeadTime);
    end;
  end;

  //  
  Set_HiFlags(Value, nsafh_DeadTime, Frs_HiFlags);
end;

procedure TDescriptor.Set_nsafh_FlipTime(const Value: Boolean);
begin
  if Value = True then
  begin
    //      " "
    if (Self.Algo = rs_algo_PI) then
      raise EDescriptorException.Create(DscE_PI_Invalid_nsafh_FlipTime);

    //      " "
    if (Self.Algo = rs_algo_LoadableCode) then
      raise EDescriptorException.Create(DscE_Code_Invalid_nsafh_FlipTime);
  end
  else
  begin
    //   ,   FlipTime
    SetNullTime(Frs_FlipTime.rs_ChangeFlipTimeStart);
    Frs_FlipTime.rs_DaysGap:= 0;
  end;

  //  
  Set_HiFlags(Value, nsafh_FlipTime, Frs_HiFlags);
end;

procedure TDescriptor.Set_nsafh_LifeTime(const Value: Boolean);
begin
  case Value of
    True:
    begin
      //      " "
      if (Self.Algo = rs_algo_PI) then
        raise EDescriptorException.Create(DscE_PI_Invalid_nsafh_LifeTime);

      //  ,    "  "
      if (Self.BirthTimeSrv = True) then
        raise EDescriptorException.Create(DscE_BithTime_Already_Set);

      //  ,    "  "
      if (Self.DeadTimeSrv = True) then
        raise EDescriptorException.Create(DscE_DeadTime_Already_Set);
    end;
    False:
    begin
      //   ,   LifeTime
      SetNullTime(Frs_Lifetime.LifeTime);
      Frs_Lifetime.State:= 0;
    end;
  end;

  //  
  Set_HiFlags(Value, nsafh_LifeTime, Frs_HiFlags);
end;

procedure TDescriptor.Set_nsafh_ReadPwd(const Value: Boolean);
begin
  //     rs_ReadPwd
  case Value of
    True:
    begin
      //   SHA256  LoadubleCode
      if (Self.Algo = rs_algo_SHA256) then
        raise EDescriptorException.Create(DscE_SHA256_UnableSet_nsafh_ReadPwd);

      if  (Self.Algo = rs_algo_LoadableCode) then
        raise EDescriptorException.Create(DscE_Code_UnableSet_nsafh_ReadPwd);

      //    
      Self.ReadSrv:= True;
    end;
    False:
    begin
      //   ,   rs_ReadPwd
      Frs_ReadPwd:= 0;
    end;
  end;

  //  
  Set_HiFlags(Value, nsafh_ReadPwd, Frs_HiFlags);
end;

procedure TDescriptor.Set_nsafh_ReadSrv(const Value: Boolean);
begin
  //     rs_K[]
  if Value = True then
  begin
    //   SHA256  LoadubleCode
    if (Self.Algo = rs_algo_SHA256) then
      raise EDescriptorException.Create(DscE_SHA256_UnableSet_nsafh_ReadSrv);

    if  (Self.Algo = rs_algo_LoadableCode) then
      raise EDescriptorException.Create(DscE_Code_UnableSet_nsafh_ReadSrv);
  end
  else
  begin
    //   ,   nsafh_ReadPwd
    Self.ReadByPwd:= False;
  end;

  //  
  Set_HiFlags(Value, nsafh_ReadSrv, Frs_HiFlags);
end;

procedure TDescriptor.Set_nsafl_ActivationSrv(const Value: Boolean);
begin
  //   ,  
  if Value = False then
    Frs_ActivatePwd:= 0;

  //  
  Set_LoFlags(Value, nsafl_ActivationSrv, Frs_LoFlags);
end;

procedure TDescriptor.Set_nsafl_DeactivationSrv(const Value: Boolean);
begin
  //   ,  
  if Value = False then
    Frs_DeactivatePwd:= 0;

  //  
  Set_LoFlags(Value, nsafl_DeactivationSrv, Frs_LoFlags);
end;

procedure TDescriptor.Set_nsafl_GP_dec(const Value: Boolean);
begin
  //   GP     .

  if Value = True then
  begin
    //      " "
    if (Self.Algo = rs_algo_PI) and (Value = True)then
      raise EDescriptorException.Create(DscE_PI_Invalid_nshafl_GP_dec);
  end
  else
  begin
    //   ,   
    Frs_GP:= 0;
  end;

  //  
  Set_LoFlags(Value, nsafl_GP_dec, Frs_LoFlags);
end;

procedure TDescriptor.Set_nsafl_InactiveFlag(const Value: Boolean);
begin
  // ,      .

  //  
  Set_LoFlags(Value, nsafl_InactiveFlag, Frs_LoFlags);
end;

procedure TDescriptor.Set_nsafl_UpdateSrv(const Value: Boolean);
begin
  //   
  if Value = True then
  begin
    //   SHA256  LoadubleCode
    if ((Self.Algo = rs_algo_SHA256)) then
      raise EDescriptorException.Create(DscE_SHA256_UnableSet_nsafl_UpdateSrv);

    if (Self.Algo = rs_algo_LoadableCode) then
      raise EDescriptorException.Create(DscE_Code_UnableSet_nsafl_UpdateSrv);
  end
  else
  begin
    //   ,  
    Frs_UpdatePwd:= 0;
  end;

  //  
  Set_LoFlags(Value, nsafl_UpdateSrv, Frs_LoFlags);
end;

procedure TDescriptor.Set_nsafl_ID(const Value: Boolean);
begin
  //     "" 
  if (Value = True) then
  begin
    if(Self.Algo = rs_algo_PI) then
      raise EDescriptorException.Create(DscE_PI_Invalid_nshafl_ID);

    if (Self.Algo = rs_algo_ECC160) then
      raise EDescriptorException.Create(DscE_ECC160_Invalid_nshafl_ID);

    if (Self.Algo = rs_algo_SHA256) then
      raise EDescriptorException.Create(DscE_SHA256_Invalid_nshafl_ID);

    if (Self.Algo = rs_algo_LoadableCode) then
      raise EDescriptorException.Create(DscE_Code_Invalid_nshafl_ID);
  end;

  //  
  Set_LoFlags(Value, nsafl_ID, Frs_LoFlags);
end;

procedure TDescriptor.Set_rs_ActivatePwd(const Value: LongWord);
begin
  //  
  Self.ActivateSrv:= True;

  //  
  Frs_ActivatePwd:= Value;
end;

procedure TDescriptor.Set_rs_Blen(const Value: LongWord);
begin
  //      
  case Self.Algo of
    rs_algo_GSII64, rs_algo_HASH64, rs_algo_RND64, rs_algo_GSII64_ENCRYPT, rs_algo_GSII64_DECRYPT:
    begin
      if (Value <> 8) then
        raise EDescriptorException.Create(DscE_XX64_InvalidBlockLength);
    end;
    rs_algo_AES128, rs_algo_AES128Encode, rs_algo_AES128Decode:
    begin
      if (Value <> 16) then
        raise EDescriptorException.Create(DscE_AES128_InvalidBlockLength);
    end;
    rs_algo_ECC160:
    begin
      if (Value <> 20) then
        raise EDescriptorException.Create(DscE_ECC160_InvalidBlockLength);
    end;
    rs_algo_SHA256:
    begin
      if (Value <> 32) then
        raise EDescriptorException.Create(DscE_SHA256_InvalidBlockLength);
    end;
    rs_algo_LoadableCode:
    begin
      if (Value <> 0) then
        raise EDescriptorException.Create(DscE_Code_InvalidBlockLength);
    end;
    rs_algo_PI:
    begin
      if (Value <> 0) then
        raise EDescriptorException.Create(DscE_PI_InvalidBlockLength);
    end;
  end;

  //  
  Frs_blen:= Value;
end;

procedure TDescriptor.Set_rs_DeactivatePwd(const Value: LongWord);
begin
  //  
  Self.DeactivateSrv:= True;

  //  
  Frs_DeactivatePwd:= Value;
end;

procedure TDescriptor.Set_rs_ErrorCounter(const Value: LongWord);
begin
  //  ,    

  if( (Self.ActivateSrv = False) and
      (Self.DeactivateSrv = False) and
      (Self.ReadByPwd = False) and
      (Self.UpdateSrv = False)
    )
  then
    raise EDescriptorException.Create(DscE_ErrorCounter_Not_Applicable);

  //  
  Frs_ErrorCounter:= Value;
end;

procedure TDescriptor.Set_rs_GP(const Value: LongWord);
begin
  //  
  Self.GP_Decrease:= True;

  //  
  Frs_GP:= Value;
end;

procedure TDescriptor.Set_rs_Klen(const Value: LongWord);
begin
  //     
  case Self.Algo of
    rs_algo_GSII64, rs_algo_HASH64, rs_algo_RND64, rs_algo_GSII64_ENCRYPT, rs_algo_GSII64_DECRYPT:
    begin
      if (Value <> 16) and (Value <> 32) then
        raise EDescriptorException.Create(DscE_XX64_InvalidDeterminantLength);
    end;
    rs_algo_AES128, rs_algo_AES128Encode, rs_algo_AES128Decode:
    begin
      if (Value <> 16) then
        raise EDescriptorException.Create(DscE_AES128_InvalidDeterminantLength);
    end;
    rs_algo_ECC160:
    begin
      if (Value <> 20) then
        raise EDescriptorException.Create(DscE_ECC160_InvalidDeterminantLength);
    end;
    rs_algo_SHA256:
    begin
      if (Value <> 0) then
        raise EDescriptorException.Create(DscE_SHA256_InvalidDeterminantLength);
    end;
    rs_algo_LoadableCode:
    begin
      if (Value < 84) then
        raise EDescriptorException.Create(DscE_Code_InvalidDeterminantLength);
    end;
    rs_algo_PI:
    begin
      if (Value = 0) then
        raise EDescriptorException.Create(DscE_PI_InvalidDeterminantLength);
    end;
  end;

  //  rs_k[]
  SetLength(Frs_K, Value);

  //  
  Frs_klen:= Value;
end;

procedure TDescriptor.Set_rs_ReadPwd(const Value: LongWord);
begin
  //  
  Self.ReadSrv:= True;
  Self.ReadByPwd:= True;

  //  
  Frs_ReadPwd:= Value;
end;

procedure TDescriptor.Set_rs_UpdatePwd(const Value: LongWord);
begin
  //  
  Self.UpdateSrv:= True;

  //  
  Frs_UpdatePwd:= Value;
end;

procedure TDescriptor.SetDeterminant(Ars_K: array of Byte);
var
  i: Integer;
begin
  //   ,     rs_K
  Self.Klen:= Length(Ars_K);

  //    ,   Frs_K
  for i := Low(Ars_K) to High(Ars_K) do
    Frs_K[i]:= Ars_K[i];
end;

procedure TDescriptor.GetDump(var ADump: TDump);
var
  Header: TSign_ItemHeader;
  DescriptorSize: Integer;
  Offset: Integer;
begin
  Header.rs_LoFlags:=       Frs_LoFlags;
  Header.rs_algo:=          Byte(Self.Algo);
  FillChar(Header.ReservedForEven[0], 2, 0);
  Header.rs_HiFlags:=       Frs_HiFlags;
  Header.rs_klen:=          Frs_Klen;
  Header.rs_blen:=          Frs_Blen;
  FillChar(Header.rs_hash[0], 8, 0);
  Header.rs_ActivatePwd:=   Frs_ActivatePwd;
  Header.rs_DeactivatePwd:= Frs_DeactivatePwd;
  Header.rs_ReadPwd:=       Frs_ReadPwd;
  Header.rs_UpdatePwd:=     Frs_UpdatePwd;
  Header.rs_BirthTime:=     Frs_BirthTime;
  Header.rs_DeadTime:=      Frs_DeadTime;
  Header.rs_Lifetime:=      Frs_Lifetime;
  Header.rs_FlipTime:=      Frs_FlipTime;
  Header.rs_GP:=            Frs_GP;
  Header.rs_ErrorCounter:=  Frs_ErrorCounter;

  //  
  DescriptorSize:= Sizeof(TSign_ItemHeader) + Frs_klen;
  SetLength(FDescriptorBuffer, DescriptorSize);

  //   
  Move(Header, FDescriptorBuffer[0], Sizeof(TSign_ItemHeader));

  //  
  Offset:= Sizeof(TSign_ItemHeader);
  Move(Frs_k[0], FDescriptorBuffer[Offset], Length(Frs_k));
  inherited GetDump(ADump);
end;

procedure TDescriptor.SetNullTime(var ATime: TGrdTime);
begin
  ATime.bSeconds:= 0;
  ATime.bMinute:=  0;
  ATime.bHour:=    0;
  ATime.bDay:=     0;
  ATime.bMonth:=   0;
  ATime.bYear:=    0;
end;

{$ENDREGION}


end.