{------------------------------------------------------------------------------}
{        (C) 1997 - 2014 Aktiv Co. All rights reserved.                        }
{ Write mask example using Guardant API Borland Delphi  (32-64 bit)            }
{------------------------------------------------------------------------------}
{ This example demonstrates Guardant API usage for writing dongles.            }
{         This code sample is for API demonstration only!                      }
{          Please do not use this code in real projects!                       }
{------------------------------------------------------------------------------}
{$REGION 'Documentation'}
/// <summary>
///        " ".
/// </summary>
{$ENDREGION}
unit grdDescriptorLoadableCode;

interface

uses System.SysUtils, grdDescriptor, GrdStructures, GrdError, GrdDelphi;

type

  {$REGION 'Documentation'}
  /// <summary>
  ///       " ".
  /// </summary>
  {$ENDREGION}
  TDescriptorLoadableCode = class (TDescriptor)
  private
    FLoadableCodeData: TGrdLoadableCodeData;
    FLoadableCodeFile: AnsiString;            //  .gcexe    
    FLoadableCodeBuff: array of Byte;         //   
    function GetVersion: Byte;
    function GetBegFlashAddr: LongWord;
    function GetEndFlashAddr: LongWord;
    function GetBegMemAddr: LongWord;
    function GetEndMemAddr: LongWord;
    function GetLoadableCode: AnsiString;
    procedure SetVersion(const Value: Byte);
    procedure SetBegFlashAddr(const Value: LongWord);
    procedure SetEndFlashAddr(const Value: LongWord);
    procedure SetBegMemAddr(const Value: LongWord);
    procedure SetEndMemAddr(const Value: LongWord);
    procedure SetLoadableCode(const Value: AnsiString);
  public
    // Constructor Destructor
    constructor Create();
    // Property
    {$REGION 'Documentation'}
    /// <summary>
    ///     Flash-,   
    ///   .
    /// </summary>
    /// <value>
    ///   Type: LongWord
    /// </value>
    {$ENDREGION}
    property BegFlashAddr: LongWord read GetBegFlashAddr write SetBegFlashAddr;
    {$REGION 'Documentation'}
    /// <summary>
    ///     Flash-,    .
    /// </summary>
    /// <value>
    ///   Type: LongWord
    /// </value>
    {$ENDREGION}
    property EndFlashAddr: LongWord read GetEndFlashAddr write SetEndFlashAddr;
    {$REGION 'Documentation'}
    /// <summary>
    ///     RAM ,    .
    /// </summary>
    /// <value>
    ///   Type: <paramref name="LongWord" />
    /// </value>
    {$ENDREGION}
    property BegMemAddr: LongWord read GetBegMemAddr write SetBegMemAddr;
    {$REGION 'Documentation'}
    /// <summary>
    ///     RAM ,    .
    /// </summary>
    /// <value>
    ///   Type: LongWord
    /// </value>
    {$ENDREGION}
    property EndMemAddr: LongWord read GetEndMemAddr write SetEndMemAddr;
    property LoadableCodeVersion: Byte read GetVersion write SetVersion;

    //   
    {$REGION 'Documentation'}
    /// <summary>
    ///         .
    /// </summary>
    /// <param name="APublicKey">
    ///   <para>
    ///     Value: array[0..39] of Byte
    ///   </para>
    ///   <para>
    ///      .  40 .
    ///   </para>
    /// </param>
    {$ENDREGION}
    procedure SetPublicKey4VerifySign(APublicKey: array of Byte);
    {$REGION 'Documentation'}
    /// <summary>
    ///         AES,  
    ///     .
    /// </summary>
    /// <param name="AprivateKey">
    ///   <para>
    ///     Value: array [0..19] of Byte
    ///   </para>
    ///   <para>
    ///      .  20 .
    ///   </para>
    /// </param>
    {$ENDREGION}
    procedure SetPrivateKey4DecryptKey(APrivateKey: array of Byte);
    property LoadableCode:    AnsiString read GetLoadableCode write SetLoadableCode;

    //    " "
    property DependsOnId:     Boolean read Get_nsafl_ID;        //  
    property GP_Counter:      LongWord read Get_rs_GP;          //  
    property GP_Decrease:     Boolean read Get_nsafl_GP_dec;    //  
    property ReadSrv:         Boolean read Get_nsafh_ReadSrv;   //  
    property ReadByPwd:       Boolean read Get_nsafh_ReadPwd;   //  
    property ReadPwd:         LongWord read Get_rs_ReadPwd;     //  
    property UpdateSrv:       Boolean read Get_nsafl_UpdateSrv; //  
    property UpdatePwd:       LongWord read Get_rs_UpdatePwd;   //  
    property FlipTimeSrv:     Boolean read Get_nsafh_FlipTime;  //  
    property FlipTime:        TGrdTime read GetFlipTime;        //  
    property FlipTimeDays:    Byte read GetFlipTimeDays;        //  
    property Klen:            LongWord read Get_rs_Klen;        //  
    property Blen:            LongWord read Get_rs_Blen;        //  

    // Vurtual
    procedure GetDump(var ADump: TDump); override;
    // Loadable Code
    procedure GetLoadableCodeDump(var ADump: TDump);
  end;

implementation

{$REGION 'TLoadableCode'}

{ TLoadableCode }

constructor TDescriptorLoadableCode.Create;
begin
  inherited Create(atLoadableCode);
  //  
  FLoadableCodeFile:= '';
  FLoadableCodeData.PublicDataLoadableCode.bLoadableCodeVersion:= 0;
  FLoadableCodeData.PublicDataLoadableCode.bReserved0:= 0;
  FLoadableCodeData.PublicDataLoadableCode.bState:= 0;
  FLoadableCodeData.PublicDataLoadableCode.bReserved:= 0;
  FLoadableCodeData.PublicDataLoadableCode.dwLoadingDate:= 0;
  FillChar(FLoadableCodeData.abLoadableCodePublicKey4VerifySign[1], 40, 0);
  FillChar(FLoadableCodeData.abLoadableCodePrivateKey4DecryptKey[1], 20, 0);
  FLoadableCodeData.dwBegFlashAddr:= 0;
  FLoadableCodeData.dwEndFlashAddr:= 0;
  FLoadableCodeData.dwBegMemAddr:= 0;
  FLoadableCodeData.dwEndMemAddr:= 0;
end;

function TDescriptorLoadableCode.GetBegFlashAddr: LongWord;
begin
  Result:= FLoadableCodeData.dwBegFlashAddr;
end;

function TDescriptorLoadableCode.GetBegMemAddr: LongWord;
begin
  Result:= FLoadableCodeData.dwBegMemAddr;
end;

procedure TDescriptorLoadableCode.GetDump(var ADump: TDump);
begin
  //      "LoadableCodeData",     rs_K[]
  SetLength(Frs_K, SizeOf(FLoadableCodeData));
  Move(FLoadableCodeData, Frs_K[0], SizeOf(FLoadableCodeData));

  //    
  Set_rs_Klen(Length(Frs_K));

  //       
  inherited GetDump(ADump);
end;

function TDescriptorLoadableCode.GetEndFlashAddr: LongWord;
begin
  Result:= FLoadableCodeData.dwEndFlashAddr;
end;

function TDescriptorLoadableCode.GetEndMemAddr: LongWord;
begin
  Result:= FLoadableCodeData.dwEndMemAddr;
end;

function TDescriptorLoadableCode.GetLoadableCode: AnsiString;
begin
  Result:= FLoadableCodeFile;
end;

procedure TDescriptorLoadableCode.GetLoadableCodeDump(var ADump: TDump);
var
  lFile: file of Byte;
  i: Integer;
begin
  if FLoadableCodeFile = '' then
    raise EDescriptorException.Create(DscE_Code_FileNotExists);

  AssignFile(lFile, FloadableCodeFile);
  Reset(lFile);
  SetLength(FLoadableCodeBuff, FileSize(lFile));

  i:= 0;
  while (not EOF(lFile)) do
  begin
    Read(lFile,  FLoadableCodeBuff[i]);
    inc(i);
  end;
  CloseFile(lFile);

  SetLength(ADump, Length(FLoadableCodeBuff));
  for i := Low(ADump) to High(ADump) do
    ADump[i]:= FLoadableCodeBuff[i];
end;

function TDescriptorLoadableCode.GetVersion: Byte;
begin
  Result:= FLoadableCodeData.PublicDataLoadableCode.bLoadableCodeVersion;
end;

procedure TDescriptorLoadableCode.SetBegFlashAddr(const Value: LongWord);
begin
  FLoadableCodeData.dwBegFlashAddr:= Value;
end;

procedure TDescriptorLoadableCode.SetBegMemAddr(const Value: LongWord);
begin
  FLoadableCodeData.dwBegMemAddr:= Value;
end;

procedure TDescriptorLoadableCode.SetEndFlashAddr(const Value: LongWord);
begin
  FLoadableCodeData.dwEndFlashAddr:= Value;
end;

procedure TDescriptorLoadableCode.SetEndMemAddr(const Value: LongWord);
begin
  FLoadableCodeData.dwEndMemAddr:= Value;
end;

procedure TDescriptorLoadableCode.SetLoadableCode(const Value: AnsiString);
begin
  if FileExists(Value) = false then
    raise EDescriptorException.Create(DscE_Code_FileNotExists);

  FLoadableCodeFile:= Value;
end;

procedure TDescriptorLoadableCode.SetPrivateKey4DecryptKey(APrivateKey: array of Byte);
var
  i: Integer;
begin
  //    20 
  if Length(APrivateKey) <> 20 then
    raise EDescriptorException.Create(DscE_Code_Invalid_PrivateKeyLength);

  for i:= 0 to High(APrivateKey) do
    FLoadableCodeData.abLoadableCodePrivateKey4DecryptKey[i + 1]:= APrivateKey[i];
end;

procedure TDescriptorLoadableCode.SetPublicKey4VerifySign(APublicKey: array of Byte);
var
  i: Integer;
begin
  //    40 
  if Length(APublicKey) <> 40 then
    raise EDescriptorException.Create(DscE_Code_Invalid_PublicKeyLength);

  for i:= 0 to High(APublicKey) do
    FLoadableCodeData.abLoadableCodePublicKey4VerifySign[i + 1]:= APublicKey[i];
end;

procedure TDescriptorLoadableCode.SetVersion(const Value: Byte);
begin
  FLoadableCodeData.PublicDataLoadableCode.bLoadableCodeVersion:= Value;
end;

{$ENDREGION}

end.