{------------------------------------------------------------------------------}
{        (C) 1997 - 2014 Aktiv Co. All rights reserved.                        }
{ Write mask example using Guardant API Borland Delphi  (32-64 bit)            }
{------------------------------------------------------------------------------}
{ This example demonstrates Guardant API usage for writing dongles.            }
{         This code sample is for API demonstration only!                      }
{          Please do not use this code in real projects!                       }
{------------------------------------------------------------------------------}
{$REGION 'Documentation'}
/// <summary>
///         Guardant Stealth III/ Net
///   III.
/// </summary>
{$ENDREGION}
unit grdDescriptorStealthIII;

interface

uses System.SysUtils, grdAbstractDescriptor, GrdStructures, GrdError, GrdDelphi;

type

  {$REGION 'Documentation'}
  /// <summary>
  ///        Guardant Stealth III/ Net III.
  /// </summary>
  {$ENDREGION}
  TDescriptorStealth3 = class(TAbstractDescriptor)
  private
    Frs_LoFlags:      Byte;     //    nsafl_xxx
    Frs_HiFlags:      Word;     //   nsafh_xxx
    //Frs_algo:         Byte;     //    rs_algo_XXXX
    Frs_klen:         Byte;     //         (rs_K[])
    Frs_blen:         Byte;     //      
    Frs_ActivatePwd:  LongWord; //   (   nsafl_ActivationSrv)
    Frs_DeactivatePwd:LongWord; //   (   nsafl_DeactivationSrv)
    Frs_ReadPwd:      LongWord; //     rs_GP,rs_ErrorCounter, rs_K[](   nsafh_ReadPwd)
    Frs_UpdatePwd:    LongWord; //     rs_GP,rs_ErrorCounter, rs_K[] ( -  nsafh_UpdateSrv)
    Frs_GP:           LongWord; //    (   nsafl_GP_dec  nsafl_GP).    1    .
    Frs_ErrorCounter: Word;     //     (      : nsafl_ActivationSrv, nsafl_DeactivationSrv, nsafl_UpdateSrv).

    function Get_nsafl_ID: Boolean;
    function Get_nsafl_GP_dec: Boolean;
    function Get_nsafl_ST_III: Boolean;
    function Get_nsafl_ActivationSrv: Boolean;
    function Get_nsafl_DeactivationSrv: Boolean;
    function Get_nsafl_UpdateSrv: Boolean;
    function Get_nsafl_InactiveFlag: Boolean;
    function Get_rs_GP: LongWord;
    function Get_rs_ActivatePwd: LongWord;
    function Get_rs_DeactivatePwd: LongWord;
    function Get_rs_UpdatePwd: LongWord;
    function Get_rs_ErrorCounter: Word;
    //function Get_rs_Algo: TAlgo;
    procedure Set_nsafl_ID(const Value: Boolean);
    procedure Set_nsafl_GP_dec(const Value: Boolean);
    procedure Set_nsafl_ActivationSrv(const Value: Boolean);
    procedure Set_nsafl_DeactivationSrv(const Value: Boolean);
    procedure Set_nsafl_UpdateSrv(const Value: Boolean);
    procedure Set_nsafl_InactiveFlag(const Value: Boolean);
    procedure Set_rs_GP(const Value: LongWord);
    procedure Set_rs_ActivatePwd(const Value: LongWord);
    procedure Set_rs_DeactivatePwd(const Value: LongWord);
    procedure Set_rs_UpdatePwd(const Value: LongWord);
    procedure Set_nsafh_ReadPwd(const Value: Boolean);
    procedure Set_rs_ReadPwd(const Value: LongWord);
    procedure Set_rs_ErrorCounter(const Value: Word);

    procedure Set_rs_Blen(const Value: Byte);
    //procedure Set_rs_Algo(const Value: TAlgo);
  protected
    Frs_K: array of Byte;        //        rs_klen.
    //  ,       " "
    function Get_rs_Klen: Byte;
    function Get_rs_Blen: Byte;
    function Get_nsafh_ReadSrv: Boolean;
    function Get_nsafh_ReadPwd: Boolean;
    function Get_rs_ReadPwd: LongWord;
    procedure Set_rs_Klen(const Value: Byte);
    procedure Set_nsafh_ReadSrv(const Value: Boolean);
    procedure CopyObject (AObject: TAbstractDescriptor); override;
    //  
    {$REGION 'Documentation'}
    /// <summary>
    ///     .
    /// </summary>
    {$ENDREGION}
    //property Algo:        TAlgo read Get_rs_Algo write Set_rs_Algo;
  public
    // Constructor Destructor
    {$REGION 'Documentation'}
    /// <summary>
    ///        .
    /// </summary>
    /// <param name="Algorithm">
    ///         .
    /// </param>
    {$ENDREGION}
    constructor Create(Algorithm: TAlgoType);
    // properties
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    ". 
    ///     rs_klen.
    /// </summary>
    /// <value>
    ///          .
    /// </value>
    /// <remarks>
    ///          
    ///       rs_K[]  ,  
    ///    .
    /// </remarks>
    {$ENDREGION}
    property Klen:            Byte read Get_rs_Klen write Set_rs_Klen;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "     ". 
    ///     rs_blen.
    /// </summary>
    /// <value>
    ///         .
    /// </value>
    {$ENDREGION}
    property Blen:            Byte read Get_rs_Blen write Set_rs_Blen;
    //    rs_LoFlags
    {$REGION 'Documentation'}
    /// <summary>
    ///    "   ID ".  
    ///    nsafl_ID   rs_LoFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    /// <remarks>
    ///          
    ///    -.     (AES128 
    ///   GSII64),     .
    /// </remarks>
    {$ENDREGION}
    property DependsOnId:     Boolean read Get_nsafl_ID write Set_nsafl_ID;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  GP     ".
    ///      nsafl_GP_dec   rs_LoFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    /// <remarks>
    ///     SHA256  .
    /// </remarks>
    {$ENDREGION}
    property GP_Decrease:     Boolean read Get_nsafl_GP_dec write Set_nsafl_GP_dec;
    {$REGION 'Documentation'}
    /// <summary>
    ///    " ".    rs_GP. <br />
    /// </summary>
    /// <value>
    ///     .  65535.
    /// </value>
    /// <remarks>
    ///       GP_Decrease  GP.
    /// </remarks>
    {$ENDREGION}
    property GP_Counter:      LongWord read Get_rs_GP write Set_rs_GP;
    {$REGION 'Documentation'}
    /// <summary>
    ///       "  ". 
    ///     nsafl_ST_III   rs_LoFlags.  
    ///   Sign, Stealth  .
    /// </summary>
    /// <value>
    ///     True.   .
    /// </value>
    {$ENDREGION}
    property ST_III:          Boolean read Get_nsafl_ST_III;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  ".   
    ///   nsafl_ActivationSrv   rs_LoFlags. <br />
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property ActivateSrv:     Boolean read Get_nsafl_ActivationSrv write Set_nsafl_ActivationSrv;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  ".   
    ///   rs_ActivatePwd.
    /// </summary>
    /// <value>
    ///     .   High (LongWord).
    /// </value>
    /// <remarks>
    ///         
    ///   ActivateSrv:= True.
    /// </remarks>
    {$ENDREGION}
    property ActivatePwd:     LongWord read Get_rs_ActivatePwd write Set_rs_ActivatePwd;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  ".   
    ///   nsafl_DeactivationSrv  <br /> rs_LoFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property DeactivateSrv:   Boolean read Get_nsafl_DeactivationSrv write Set_nsafl_DeactivationSrv;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  ".   
    ///   rs_DeactivatePwd.
    /// </summary>
    /// <value>
    ///     .   High (LongWord).
    /// </value>
    /// <remarks>
    ///         
    ///   DeactivateSrv:= True.
    /// </remarks>
    {$ENDREGION}
    property DeactivatePwd:   LongWord read Get_rs_DeactivatePwd write Set_rs_DeactivatePwd;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "   rs_K[]".   
    ///   nsafl_UpdateSrv   rs_LoFlags. <br />
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property UpdateSrv:       Boolean read Get_nsafl_UpdateSrv write Set_nsafl_UpdateSrv;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    rs_GP, rs_ErrorCounter, rs_K[]
    ///   ".    rs_UpdatePwd.
    /// </summary>
    /// <value>
    ///        .   High
    ///   (LongWord).
    /// </value>
    /// <remarks>
    ///         
    ///   UpdateSrv:= True.
    /// </remarks>
    {$ENDREGION}
    property UpdatePwd:       LongWord read Get_rs_UpdatePwd write Set_rs_UpdatePwd;
    {$REGION 'Documentation'}
    /// <summary>
    ///    " ".   
    ///   nsafl_InactiveFlag   rs_LoFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property InactiveFlag:    Boolean read Get_nsafl_InactiveFlag write Set_nsafl_InactiveFlag;
    //    rs_HiFlags
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    rs_K[] ".  
    ///    nsafh_ReadSrv   rs_HiFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property ReadSrv:         Boolean read Get_nsafh_ReadSrv write Set_nsafh_ReadSrv;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "     ". 
    ///     nsafh_ReadPwd   rs_HiFlags.
    /// </summary>
    /// <value>
    ///    True  , False  .
    /// </value>
    {$ENDREGION}
    property ReadByPwd:       Boolean read Get_nsafh_ReadPwd write Set_nsafh_ReadPwd;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    rs_GP, rs_ErrorCounter, rs_K[] ".
    ///      rs_ReadPwd.
    /// </summary>
    /// <value>
    ///        .   High
    ///   (LongWord).
    /// </value>
    /// <remarks>
    ///         
    ///   ReadSrv:= True  ReadByPwd:= True.
    /// </remarks>
    {$ENDREGION}
    property ReadPwd:         LongWord read Get_rs_ReadPwd write Set_rs_ReadPwd;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "   ".  
    ///    rs_ErrorCounter.
    /// </summary>
    /// <value>
    ///      .   High (Word).
    /// </value>
    /// <remarks>
    ///     ,       :
    ///   Activaterv, DeactivateSrv, UpdateSrv  ReadByPwd.
    /// </remarks>
    {$ENDREGION}
    property ErrorCounter:    Word read Get_rs_ErrorCounter write Set_rs_ErrorCounter;
    // Determinant
    {$REGION 'Documentation'}
    /// <summary>
    ///         
    ///     (  rs_K[] ) .
    /// </summary>
    /// <param name="Ars_K">
    ///          , 
    ///   rs_klen.
    /// </param>
    /// <remarks>
    ///        rs_klen  
    ///     (Length(Ars_k)).
    /// </remarks>
    {$ENDREGION}
    procedure SetDeterminant(Ars_K: array of Byte);
    // Vurtual
    {$REGION 'Documentation'}
    /// <summary>
    ///          
    ///   .
    /// </summary>
    /// <param name="ADump">
    ///     TDump (array of Byte)     
    ///   .
    /// </param>
    {$ENDREGION}
    procedure GetDump(var ADump: TDump); override;
  end;
  
implementation

{$REGION 'TStealthIII'}

{ TStealthIII }

constructor TDescriptorStealth3.Create(Algorithm: TAlgoType);
begin
  //  
  Self.DescriptorType:= dtStealthIII;

  //  
  Frs_LoFlags:=       0;
  Frs_HiFlags:=       0;
  //Frs_algo:=          0;
  Frs_klen:=          0;
  Frs_blen:=          0;
  Frs_ActivatePwd:=   0;
  Frs_DeactivatePwd:= 0;
  Frs_ReadPwd:=       0;
  Frs_UpdatePwd:=     0;
  Frs_GP:=            0;
  Frs_ErrorCounter:=  0;

  //         
  case Algorithm of
    atGSII64:
    begin
      Set_rs_Algo(rs_algo_GSII64);
      Frs_klen:= 16;  //  32
      Frs_blen:= 8;   //  
    end;
    atHASH64:
    begin
      Set_rs_Algo(rs_algo_HASH64);
      Frs_klen:= 16;  //  32
      Frs_blen:= 8;   //  
    end;
    atRAND64:
    begin
      Set_rs_Algo(rs_algo_RND64);
      Frs_klen:= 16;  //  32
      Frs_blen:= 8;   //  
    end;
    atProtectedItem:
    begin
      Set_rs_Algo(rs_algo_PI);
      Frs_klen:= 8; // max value = SizeOf(LongWord)
      Frs_blen:= 0; //  
    end;
  else
    raise EDescriptorException.Create(DscE_InvalidAlgoFlag);
  end;

  //    
  Set_LoFlags(True, nsafl_ST_III, Frs_LoFlags);
end;

procedure TDescriptorStealth3.CopyObject(AObject: TAbstractDescriptor);
var
  i: Integer;
begin
  Self.DescriptorType:= (AObject as TDescriptorStealth3).DescriptorType;

  Self.Frs_LoFlags:=  (AObject as TDescriptorStealth3).Frs_LoFlags;
  Self.Frs_HiFlags:=  (AObject as TDescriptorStealth3).Frs_HiFlags;
  //Self.Frs_algo:=     (AObject as TStealthIII).Frs_algo;
  Self.Frs_klen:=     (AObject as TDescriptorStealth3).Frs_klen;
  Self.Frs_blen:=     (AObject as TDescriptorStealth3).Frs_blen;
  Self.Frs_ActivatePwd:=    (AObject as TDescriptorStealth3).Frs_ActivatePwd;
  Self.Frs_DeactivatePwd:=  (AObject as TDescriptorStealth3).Frs_DeactivatePwd;
  Self.Frs_ReadPwd:=        (AObject as TDescriptorStealth3).Frs_ReadPwd;
  Self.Frs_UpdatePwd:=      (AObject as TDescriptorStealth3).Frs_UpdatePwd;
  Self.Frs_GP:=             (AObject as TDescriptorStealth3).Frs_GP;
  Self.Frs_ErrorCounter:=   (AObject as TDescriptorStealth3).Frs_ErrorCounter;
  SetLength(Self.Frs_K, Length((AObject as TDescriptorStealth3).Frs_K));
  for i:= Low((AObject as TDescriptorStealth3).Frs_K) to High((AObject as TDescriptorStealth3).Frs_K) do
  Self.Frs_K[i]:= (AObject as TDescriptorStealth3).Frs_K[i];
end;

procedure TDescriptorStealth3.GetDump(var ADump: TDump);
var
  Header: TGS3_ItemHeader;
  DescriptorSize: Integer;
  Offset: Integer;
begin
  //       ( 6 )
  Header.rs_LoFlags:= Frs_LoFlags;
  Header.rs_HiFlags:= Frs_HiFlags;
  Header.rs_algo:=    Byte(Self.Algo);
  Header.rs_klen:=    Frs_Klen;
  Header.rs_blen:=    Frs_Blen;

  //    
  DescriptorSize:= 6;
  SetLength(FDescriptorBuffer, DescriptorSize);
  Move(Header, FDescriptorBuffer[0], DescriptorSize);

  //  ,      
  Header.rs_ActivatePwd:= Frs_ActivatePwd;
  if Self.ActivateSrv = True then
  begin
    Offset:= DescriptorSize;
    DescriptorSize:= DescriptorSize + SizeOf(Frs_ActivatePwd);
    SetLength(FDescriptorBuffer, DescriptorSize);
    //    
    Move(Frs_ActivatePwd, FDescriptorBuffer[Offset], SizeOf(Frs_ActivatePwd));
  end;

  Header.rs_DeactivatePwd:= Frs_DeactivatePwd;
  if Self.DeactivateSrv = True then
  begin
    Offset:= DescriptorSize;
    DescriptorSize:= DescriptorSize + SizeOf(Frs_DeactivatePwd);
    SetLength(FDescriptorBuffer, DescriptorSize);
    //    
    Move(Frs_DeactivatePwd, FDescriptorBuffer[Offset], SizeOf(Frs_DeactivatePwd));
  end;

  Header.rs_ReadPwd:= Frs_ReadPwd;
  if Self.ReadByPwd = True then
  begin
    Offset:= DescriptorSize;
    DescriptorSize:= DescriptorSize + SizeOf(Frs_ReadPwd);
    SetLength(FDescriptorBuffer, DescriptorSize);
    //    
    Move(Frs_ReadPwd, FDescriptorBuffer[Offset], SizeOf(Frs_ReadPwd));
  end;

  Header.rs_UpdatePwd:= Frs_UpdatePwd;
  if Self.UpdateSrv = True then
  begin
    Offset:= DescriptorSize;
    DescriptorSize:= DescriptorSize + SizeOf(Frs_UpdatePwd);
    SetLength(FDescriptorBuffer, DescriptorSize);
    //    
    Move(Frs_UpdatePwd, FDescriptorBuffer[Offset], SizeOf(Frs_UpdatePwd));
  end;

  Header.rs_GP:= Frs_GP;
  if Self.GP_Decrease = True then
  begin
    Offset:= DescriptorSize;
    DescriptorSize:= DescriptorSize + SizeOf(Frs_GP);
    SetLength(FDescriptorBuffer, DescriptorSize);
    //    
    Move(Frs_GP, FDescriptorBuffer[Offset], SizeOf(Frs_GP));
  end;

  //     ,   
  Header.rs_ErrorCounter:= Frs_ErrorCounter;
  if (
        (Self.ActivateSrv = True) or
        (Self.DeactivateSrv = True) or
        (Self.ReadByPwd = True) or
        (Self.UpdateSrv = True)
    )
  then
  begin
    Offset:= DescriptorSize;
    DescriptorSize:= DescriptorSize + SizeOf(Frs_ErrorCounter);
    SetLength(FDescriptorBuffer, DescriptorSize);
    //     
    Move(Frs_ErrorCounter, FDescriptorBuffer[Offset], SizeOf(Frs_ErrorCounter));
  end;

  //  
  Offset:= DescriptorSize;
  DescriptorSize:= DescriptorSize + Length(Frs_k);
  SetLength(FDescriptorBuffer, DescriptorSize);

  Move(Frs_k[0], FDescriptorBuffer[Offset], Length(Frs_k));

  //   ADump
  inherited GetDump(ADump);
end;

function TDescriptorStealth3.Get_nsafh_ReadPwd: Boolean;
begin
  Result:= Get_HiFlags(nsafh_ReadPwd, Frs_HiFlags);
end;

function TDescriptorStealth3.Get_nsafh_ReadSrv: Boolean;
begin
  Result:= Get_HiFlags(nsafh_ReadSrv, Frs_HiFlags);
end;

function TDescriptorStealth3.Get_nsafl_ActivationSrv: Boolean;
begin
  Result:= Get_LoFlags(nsafl_ActivationSrv, Frs_LoFlags);
end;

function TDescriptorStealth3.Get_nsafl_DeactivationSrv: Boolean;
begin
  Result:= Get_LoFlags(nsafl_DeactivationSrv, Frs_LoFlags);
end;

function TDescriptorStealth3.Get_nsafl_GP_dec: Boolean;
begin
  Result:= Get_LoFlags(nsafl_GP_dec, Frs_LoFlags);
end;

function TDescriptorStealth3.Get_nsafl_InactiveFlag: Boolean;
begin
  Result:= Get_LoFlags(nsafl_InactiveFlag, Frs_LoFlags);
end;

function TDescriptorStealth3.Get_nsafl_ST_III: Boolean;
begin
  Result:= Get_LoFlags(nsafl_ST_III, Frs_LoFlags);
end;

function TDescriptorStealth3.Get_nsafl_UpdateSrv: Boolean;
begin
  Result:= Get_LoFlags(nsafl_UpdateSrv, Frs_LoFlags);
end;

function TDescriptorStealth3.Get_nsafl_ID: Boolean;
begin
  Result:= Get_LoFlags(nsafl_ID, Frs_LoFlags);
end;

function TDescriptorStealth3.Get_rs_ActivatePwd: LongWord;
begin
  Result:= Frs_ActivatePwd;
end;

//function TStealthIII.Get_rs_Algo: TAlgo;
//begin
//  Result:= TAlgo(Frs_algo);
//end;

function TDescriptorStealth3.Get_rs_Blen: Byte;
begin
  Result:= Frs_blen;
end;

function TDescriptorStealth3.Get_rs_DeactivatePwd: LongWord;
begin
  Result:= Frs_DeactivatePwd;
end;

function TDescriptorStealth3.Get_rs_ErrorCounter: Word;
begin
  Result:= Frs_ErrorCounter;
end;

function TDescriptorStealth3.Get_rs_GP: LongWord;
begin
  Result:= Frs_GP;
end;

function TDescriptorStealth3.Get_rs_Klen: Byte;
begin
  Result:= Frs_klen;
end;

function TDescriptorStealth3.Get_rs_ReadPwd: LongWord;
begin
  Result:= Frs_ReadPwd;
end;

function TDescriptorStealth3.Get_rs_UpdatePwd: LongWord;
begin
  Result:= Frs_UpdatePwd;
end;

procedure TDescriptorStealth3.SetDeterminant(Ars_K: array of Byte);
var
  i: Integer;
begin
  //   ,     rs_K
  Self.Klen:= Length(Ars_K);

  //    ,   Frs_K
  for i := Low(Ars_K) to High(Ars_K) do
    Frs_K[i]:= Ars_K[i];
end;

procedure TDescriptorStealth3.Set_nsafh_ReadPwd(const Value: Boolean);
begin
  //     rs_ReadPwd

  case Value of
    True:
    begin
      //    
      Self.ReadSrv:= True;
    end;
    False:
    begin
      //   ,   rs_ReadPwd
      Frs_ReadPwd:= 0;
    end;
  end;

  //  
  Set_HiFlags(Value, nsafh_ReadPwd, Frs_HiFlags);
end;

procedure TDescriptorStealth3.Set_nsafh_ReadSrv(const Value: Boolean);
begin
  //     rs_K[] 

  //   ,   nsafh_ReadPwd
  if Value = False then
    Self.ReadByPwd:= False;

  //  
  Set_HiFlags(Value, nsafh_ReadSrv, Frs_HiFlags);
end;

procedure TDescriptorStealth3.Set_nsafl_ActivationSrv(const Value: Boolean);
begin
  //   ,  
  if Value = False then
    Frs_ActivatePwd:= 0;

  //  
  Set_LoFlags(Value, nsafl_ActivationSrv, Frs_LoFlags);
end;

procedure TDescriptorStealth3.Set_nsafl_DeactivationSrv(const Value: Boolean);
begin
  //   ,  
  if Value = False then
    Frs_DeactivatePwd:= 0;

  //  
  Set_LoFlags(Value, nsafl_DeactivationSrv, Frs_LoFlags);
end;

procedure TDescriptorStealth3.Set_nsafl_GP_dec(const Value: Boolean);
begin
  //   GP     .

  //      " "
  if (Self.Algo = rs_algo_PI) and (Value = True)then
  begin
    raise EDescriptorException.Create(DscE_PI_Invalid_nshafl_GP_dec);
  end;

  //   ,   
  if Value = False then
    Frs_GP:= 0;

  //  
  Set_LoFlags(Value, nsafl_GP_dec, Frs_LoFlags);
end;

procedure TDescriptorStealth3.Set_nsafl_InactiveFlag(const Value: Boolean);
begin
  // ,      .

  //  
  Set_LoFlags(Value, nsafl_InactiveFlag, Frs_LoFlags);
end;

procedure TDescriptorStealth3.Set_nsafl_UpdateSrv(const Value: Boolean);
begin
  //   

  //   ,  
  if Value = False then
    Frs_UpdatePwd:= 0;

  //  
  Set_LoFlags(Value, nsafl_UpdateSrv, Frs_LoFlags);
end;

procedure TDescriptorStealth3.Set_nsafl_ID(const Value: Boolean);
begin
  //     "" 
  if( (Self.Algo = rs_algo_PI) and (Value = True))
  then
    raise EDescriptorException.Create(DscE_PI_Invalid_nshafl_ID);

  //  
  Set_LoFlags(Value, nsafl_ID, Frs_LoFlags);
end;

procedure TDescriptorStealth3.Set_rs_ActivatePwd(const Value: LongWord);
begin
  //  
  Self.ActivateSrv:= True;

  //  
  Frs_ActivatePwd:= Value;
end;

//procedure TStealthIII.Set_rs_Algo(const Value: TAlgo);
//begin
//  Frs_algo:= Byte(Value);
//end;

procedure TDescriptorStealth3.Set_rs_Blen(const Value: Byte);
begin
  //      
  case Self.Algo of
    rs_algo_GSII64, rs_algo_HASH64, rs_algo_RND64:
    begin
      if (Value <> 8) then
        raise EDescriptorException.Create(DscE_XX64_InvalidBlockLength);
    end;
    rs_algo_PI:
    begin
      if (Value <> 0) then
        raise EDescriptorException.Create(DscE_PI_InvalidBlockLength);
    end;
  end;
  //  
  Frs_blen:= Value;
end;

procedure TDescriptorStealth3.Set_rs_DeactivatePwd(const Value: LongWord);
begin
  //  
  Self.DeactivateSrv:= True;

  //  
  Frs_DeactivatePwd:= Value;
end;

procedure TDescriptorStealth3.Set_rs_ErrorCounter(const Value: Word);
begin
  //  ,    
  if( (Self.ActivateSrv = False) and
      (Self.DeactivateSrv = False) and
      (Self.ReadByPwd = False) and
      (Self.UpdateSrv = False)
    )
  then
    raise EDescriptorException.Create(DscE_ErrorCounter_Not_Applicable);

  //  
  Frs_ErrorCounter:= Value;
end;

procedure TDescriptorStealth3.Set_rs_GP(const Value: LongWord);
begin
  //  
  Self.GP_Decrease:= True;

  //  
  Frs_GP:= Value;
end;

procedure TDescriptorStealth3.Set_rs_Klen(const Value: Byte);
begin
  //     
  case Self.Algo of
    rs_algo_GSII64, rs_algo_HASH64, rs_algo_RND64:
    begin
      if (Value <> 16) and (Value <> 32) then
        raise EDescriptorException.Create(DscE_XX64_InvalidDeterminantLength);
    end;
    rs_algo_PI:
    begin
      if (Value = 0) then
        raise EDescriptorException.Create(DscE_PI_InvalidDeterminantLength);
    end;
  end;

  //  rs_k[]
  SetLength(Frs_K, Value);
  //  
  Frs_klen:= Value;
end;

procedure TDescriptorStealth3.Set_rs_ReadPwd(const Value: LongWord);
begin
  //  
  Self.ReadSrv:= True;
  Self.ReadByPwd:= True;

  //  
  Frs_ReadPwd:= Value;
end;

procedure TDescriptorStealth3.Set_rs_UpdatePwd(const Value: LongWord);
begin
  //  
  Self.UpdateSrv:= True;

  //  
  Frs_UpdatePwd:= Value;
end;

{$ENDREGION}

end.