{------------------------------------------------------------------------------}
{        (C) 1997 - 2014 Aktiv Co. All rights reserved.                        }
{ Write mask example using Guardant API Borland Delphi  (32-64 bit)            }
{------------------------------------------------------------------------------}
{ This example demonstrates Guardant API usage for writing dongles.            }
{         This code sample is for API demonstration only!                      }
{          Please do not use this code in real projects!                       }
{------------------------------------------------------------------------------}
{$REGION 'Documentation'}
/// <summary>
///       Guardant API  TDescriptor.
/// </summary>
{$ENDREGION}
unit GrdError;

interface
uses System.SysUtils, grddelphi;

type
  {$REGION 'Documentation'}
  /// <summary>
  ///      Guardant API.
  /// </summary>
  {$ENDREGION}
  EGrdExeption = class(Exception)
    FErrCode: LongWord;
    constructor Create(AErrCode: Integer); overload;
  end;

  {$REGION 'Documentation'}
  /// <summary>
  ///      TDescriptor.
  /// </summary>
  {$ENDREGION}
  EDescriptorException = class(Exception)
    FErrCode: LongWord;
    constructor Create(AErrCode: LongWord); overload;
  end;

const
  // Descriptor Error Codes
  DscE_OK = 0;
  DscE_InvalidAlgoFlag = 1;
  DscE_GS2_Random_UnableUnsetGP = 2;
  DscE_GS2_Random_UnableUnsetGP_dec = 3;
  DscE_GS2_Fast_UnableSetGP = 4;
  DscE_GS2_Fast_UnubleSetGP_dec = 5;
  DscE_GS2_Fast_InvalidDeterminantLength = 6;
  DscE_GS2_Fast_InvalidBlockLength = 7;
  DscE_GS2_InvalidDeterminantLength = 8;
  DscE_GS2_InvalidBlockLength = 9;
  DscE_GS2_UnableSet_rs_GP = 10;
  DscE_XX64_InvalidDeterminantLength = 11;
  DscE_XX64_InvalidBlockLength = 12;
  DscE_AES128_InvalidDeterminantLength = 13;
  DscE_AES128_InvalidBlockLength = 14;
  DscE_ECC160_InvalidDeterminantLength = 15;
  DscE_ECC160_InvalidBlockLength = 16;
  DscE_ECC160_Invalid_nshafl_ID = 17;
  DscE_SHA256_InvalidDeterminantLength = 18;
  DscE_SHA256_InvalidBlockLength = 19;
  DscE_SHA256_Invalid_nshafl_ID = 20;
  DscE_SHA256_UnableSet_nsafh_ReadPwd = 21;
  DscE_SHA256_UnableSet_nsafh_ReadSrv = 22;
  DscE_SHA256_UnableSet_nsafl_UpdateSrv = 23;
  DscE_Code_InvalidDeterminantLength = 24;
  DscE_Code_InvalidBlockLength = 25;
  DscE_Code_UnableSet_nsafh_ReadSrv = 26;
  DscE_Code_UnableSet_nsafh_ReadPwd = 27;
  DscE_Code_UnableSet_nsafl_UpdateSrv = 28;
  DscE_Code_Invalid_nsafh_FlipTime = 29;
  DscE_Code_Invalid_nshafl_ID = 30;
  DscE_Code_Invalid_PrivateKeyLength = 31;
  DscE_Code_Invalid_PublicKeyLength = 32;
  DscE_Code_FileNotExists = 33;
  DscE_PI_Invalid_nshafl_ID = 34;
  DscE_PI_Invalid_nshafl_GP_dec = 35;
  DscE_PI_InvalidDeterminantLength = 36;
  DscE_PI_Invalid_nsafh_BirthTime = 37;
  DscE_PI_Invalid_nsafh_DeadTime = 38;
  DscE_PI_Invalid_nsafh_FlipTime = 39;
  DscE_PI_Invalid_nsafh_LifeTime = 40;
  DscE_PI_InvalidBlockLength = 41;
  DscE_BithTime_Already_Set = 42;
  DscE_DeadTime_Already_Set = 43;
  DscE_LifeTime_Already_Set = 44;
  DscE_ErrorCounter_Not_Applicable = 45;
  DscE_Lms_SizeTooBig = 46;
  DscE_Lms_InvalidModuleSize = 47;
  DscE_Lms_InvalidModuleIndex = 48;
  DscE_InvalidDescriptorType = 49;
  DscE_InvalidDescriptorNum = 50;
  DscE_InvalidDescriptorOrder = 51;
  DscE_Lms_NotCompatible = 52;
  DscE_Lms_AlreadyExists = 53;
  DscE_UnknownDongle = 54;
  DscE_TruKey_InvalidLength = 55;
  DscE_NotEnoughRam = 56;
  DscE_InvalidDongleType = 57;
  DscE_InvalidPublicCodes = 58;
  DscE_UnableSet_GlobalFlags = 59;
  DscE_Invalid_Algorithm = 60;
  DscE_InvalidDescriptorPointer = 61;
var
  {$REGION 'Documentation'}
  /// <summary>
  ///     TDescriptor   .
  /// </summary>
  {$ENDREGION}
  DescriptorErrorRus: array [0..62] of string = (
	' .', // 0
  '     .', // 1
  '  Random    "  " (nsafl_GP).', // 2
  '  Random    "  " (nsafl_GP_dec).', // 3
  '  Fast     "  " (nsafl_GP).', // 4
  '  Fast   "  " (nsafl_GP_dec).', // 5
  '   Fast   = 8   (rs_Klen).', // 6
  '    Fast   = 32   (rs_Blen).', // 7
  '   Stealth II      4  200   (rs_Klen).', // 8
  '    Stealth II    4   (rs_Blen).', // 9
  '       "  " (nsafl_GP)  "  " (nsafl_GP_dec).', // 10
  '   GSII64, HASH64  RAND64   = 16  32   (rs_Klen).', // 11
  '    GSII64 HASH64  RAND64   = 8   (rs_Blen).', // 12
  '   AES128   = 16  (rs_Klen).', // 13
  '    AES128   = 16   (rs_Blen).', // 14
  '   ECC160    = 20   (rs_Klen).', // 15
  '    ECC160   = 20   (rs_Blen).', // 16
  '  ECC160     "  " (nsafl_GP).', // 17
  '   SHA256   = 0  (rs_Klen).', // 18
  '    SHA256   = 32   (rs_Blen).', // 19
  '  SHA256     "  " (nsafl_GP).', // 20
  '  SHA256    "  " (nsafh_ReadPwd).', // 21
  '  SHA256    " " (nsafh_ReadSrv).', // 22
  '  SHA256    " " (nsafh_UpdateSrv).', // 23
  '       = 84  (rs_Klen).', // 24
  '         = 0 (rs_Blen).', // 25
  '        " " (nsafh_ReadSrv).', // 26
  '        "  " (nsafh_ReadPwd).', // 27
  '        " " (nsafh_UpdateSrv).', // 28
  '        FlipTime (nsafh_FlipTime).', // 29
  '         "  " (nsafl_GP).', // 30
  '        = 20 .', // 31
  '      = 40 .', // 32
  '    .', // 33
  '         "  " (nsafl_GP).', // 34
  '       "  " (nsafl_GP_dec).', // 35
  '          = 0  (rs_Klen).', // 36
  '        BirthTime (nsafh_BirthTime).', // 37
  '        DeadTime (nsafh_DeadTime).', // 38
  '        FlipTime (nsafh_FlipTime).', // 39
  '        LifeTime (nsafh_LifeTime).', // 40
  '          = 0  (rs_Blen).', // 41
  ' LifeTime     ..   BirthTime.', // 42
  ' LifeTime     ..   DeadTime.', // 43
  ' BirthTime  DeadTime     ..   LifeTime. ', // 44
  '  ErrorCounter  ActivationSrv, DeactivationSrv, UpdateSrv  ReadByPwd.', // 45
  '  LMS  126.', // 46
  '   LMS  255. Flag2Bytes  .', // 47
  '      LMS  .', // 48
  '        Guardant.', // 49
  '    $FF00.', // 50
  '  Stealth II  Stealth III       .', // 51
  ' LMS      Guardant.', // 52
  ' LMS     .', // 53
  '  .', // 54
  '      = 16 .', // 55
  '       .', // 56
  '     .', // 57
  '       .', // 58
  '       Sign  .', // 59
  '      .', // 60
  '   .     ', // 61
  'reserved'

  );

  {$REGION 'Documentation'}
  /// <summary>
  ///     Guardant API   .
  /// </summary>
  {$ENDREGION}
  aszGrdErrorRus: array [0..GrdE_LastError] of string =
		//- Error codes ( Russian )
(
	' ',                                                                                                        // 00
	'      ',                                                                       // 01
	'  ',                                                                                              // 02
	'   ',                                                                                      // 03
	'    p  ',                                                                    // 04
	' GP  0',                                                                                               // 05
	'p ',                                                                                                  // 06
	'- p ',                                                                                               // 07
	' ',                                                                                                // 08
	' p  ',                                                                                        // 09
	' pp pp p',                                                                                 // 10
	'   Guardant Net p',                                                                       // 11
	' Guardant Net  ',                                                                                     // 12
	'     Guardant Net',                                                                // 13
	' DPMI',                                                                                                       // 14
	'p  cpp Guardant Net',                                                                            // 15
	'pp Guardant Net  pp',                                                                              // 16
	'  p   ',                                                                           // 17
	'NT pp  ',                                                                                              // 18
	'  ',                                                                                         // 19
	'   ',                                                                               // 20
	'   Login',                                                                                // 21
	'   Logout',                                                                               // 22
	'   ',                                                                                     // 23
	'    LPT ',                                                                                  // 24
	' #25',                                                                                               // 25
	' #26',                                                                                               // 26
	' #27',                                                                                               // 27
	' #28',                                                                                               // 28
	' #29',                                                                                               // 29
	' CRC',                                                                                                        // 30
	' CRC  ',                                                                                             // 31
	' CRC  ',                                                                                             // 32
	'    ',                                                                                   // 33
	'  p   ',                                                                        // 34
	' CRC   p',                                                                               // 35
	'GrdE_AllDonglesFound:   ',                                                                         // 36
	' NSK p   ',                                                                              // 37
	'   op pp',                                                                // 38
	'     /,    ',                                 // 39
	'  ',                                                                                         // 40
	'     ',                                                        // 41
	'  /     ',                                                   // 42
	'/    Inactive,   ',                                              // 43
	'  ,     -',                                           // 44
	'        ',                                                          // 45
	'    ',                                                                         // 46
	'  ',                                                                                       // 47
	' ',                                                                                                // 48
	'    ',                                                                        // 49
	' #50',                                                                                               // 50
	' #51',                                                                                               // 51
	' #52',                                                                                               // 52
	'   ',                                                                             // 53
	'      ',                                                              // 54
	'     ',                                                              // 55
	'     ',                                                                 // 56
	'      ',                                                            // 57
	'     ',                                                               // 58
	' ',                                                                                                 // 59
	'  Guardant API  ',                                                                 // 60
	' ',                                                                                                    // 61
	'  ',                                                                                            // 62
	'  /    ART',                                                               // 63
	'   AAT   EEPROM',                                                                          // 64
	'   ',                                                                                   // 65
	'  ',                                                                                               // 66
	'  ',                                                                                         // 67
	'    ',                                                                            // 68
	'    ',                                                                           // 69
	'  ',                                                                                           // 70
	'   Guardant API',                                                               // 71
	'   ',                                                                              // 72
	'       ',                                                             // 73
	'     flash-   ',                          // 74
	' #75',                                                                                               // 75
	' #76',                                                                                               // 76
	' #77',                                                                                               // 77
	' #78',                                                                                               // 78
	' #79',                                                                                               // 79
	'     TGrdLoadableCodeData',                                                 // 80
	'   RAM-   ',                                                   // 81
	'   FLASH-   ',                                                 // 82
	'  FLASH-    ',                                              // 83
	'  BMAP ',                                                                                         // 84
	'   ',                                                                               // 85
	'   ',                                                                                        // 86
	'   ',                                                                                   // 87
	'   ',                                                                            // 88
	'    /   /   ',       // 89
	'       ',                                                  // 90
	' /,    ,     ',                       // 91
	'     FLASH-.',                                                                 // 92
	'         (  Init)', // 93
	'   GCEXE',                                                                                   // 94
	'        GcaCodeRun',                                           // 95
	'    GcaCodeRun',
  '  ini-     API',                                                                        // 96
	'  #'                                                                                               // 97 (all errors >= GrdE_LastError )
  )
;

{$REGION 'Documentation'}
/// <summary>
///     Guardant API   .
/// </summary>
{$ENDREGION}
aszGrdErrorEng: array [0..GrdE_LastError] of string =
		//- Error codes ( English )
(
	'No errors',                                                                                             // 00
	'Dongle with specified search conditions not found',                                                     // 01
	'Code not found',                                                                                        // 02
	'The specified address is too big',                                                                      // 03
	'Byte counter too big',                                                                                  // 04
	'GP executions counter exhausted (has 0 value)',                                                         // 05
	'Invalid dongle call command',                                                                           // 06
	'Write time out error',                                                                                  // 07
	'Write verification error',                                                                              // 08
	'Network protocol not found',                                                                            // 09
	'License counter of Guardant Net exhausted',                                                             // 10
	'Connection with Guardant Net server was lost',                                                          // 11
	'Guardant Net server not found',                                                                         // 12
	'Guardant Net server memory allocation error',                                                           // 13
	'Guardant Net server found DPMI error',                                                                  // 14
	'Guardant Net server internal error',                                                                    // 15
	'Guardant Net server has been reloaded',                                                                 // 16
	'This command is not supported by this dongle version (the version is too old)',                         // 17
	'Windows NT driver is required',                                                                         // 18
	'Network protocol error',                                                                                // 19
	'Network packet format is not supported',                                                                // 20
	'Logging in Guardant dongle is required',                                                                // 21
	'Logging out from Guardant dongle is required',                                                          // 22
	'Guardant dongle locked by another copy of protected application',                                       // 23
	'Guardant driver cannot capture the parallel port',                                                      // 24
	'Reserved #25',                                                                                          // 25
	'Reserved #26',                                                                                          // 26
	'Reserved #27',                                                                                          // 27
	'Reserved #28',                                                                                          // 28
	'Reserved #29',                                                                                          // 29
	'CRC error occurred while attempting to call the dongle',                                                // 30
	'CRC error occurred while attempting to read data from the dongle',                                      // 31
	'CRC error occurred while attempting to write data to the dongle',                                       // 32
	'The boundary of the dongles memory has been override',                                                 // 33
	'The hardware algorithm with specified number has not been found in the dongle',                         // 34
	'CRC error of the hardware algorithm',                                                                   // 35
	'All dongles found, or CRC error occurred while attempting to execute ChkNSK operation',                 // 36
	'Guardant API release is too old',                                                                       // 37
	'Non-existent reversible conversion method has been specified',                                          // 38
	'Unknown error in work with algorithm or protected item, operation may by not complete',                 // 39
	'Invalid activation password',                                                                           // 40
	'Error counter exhaust',                                                                                 // 41
	'Specifed algorithm or protected item not support requested service',                                    // 42
	'This is a inactive algorithm or protected item, command not executed',                                  // 43
	'Dongle server not support specifed command',                                                            // 44
	'Dongle busy at this moment and cant execute any command',                                              // 45
	'One or more function arguments are invalid',                                                            // 46
	'Memory allocation error',                                                                               // 47
	'Invalid handle',                                                                                        // 48
	'This protected container is already in use',                                                            // 49
	'Reserved #50',                                                                                          // 50
	'Reserved #51',                                                                                          // 51
	'Reserved #52',                                                                                          // 52
	'Remote update system data corrupted',                                                                   // 53
	'Remote update question has not been generated',                                                         // 54
	'Invalid remote update data format',                                                                     // 55
	'Remote update question has been already generated',                                                     // 56
	'Remote update writing has not been completed',                                                          // 57
	'Invalid remote update data hash',                                                                       // 58
	'Internal error',                                                                                        // 59
	'This copy of Guardant API has been already initialized',                                                // 60
	'Real Time Clock error',                                                                                 // 61
	'Real Time Clock battery low error',                                                                     // 62
	'Duplicate items/algorithms names',                                                                      // 63
	'Address in AAT table is out of range',                                                                  // 64
	'Session key not generated',                                                                             // 65
	'Invalid public key',                                                                                    // 66
	'Invalid digital sign',                                                                                  // 67
	'Session key generation error',                                                                          // 68
	'Invalid session key',                                                                                   // 69
	'Session key too old',                                                                                   // 70
	'Guardant API must be initialized',                                                                      // 71
	'Verification of loadable code failed',                                                                  // 72
	'Loadable code execute time out',                                                                        // 73
	'Flash-size from descriptor for User Firmware too small',                                                // 74
	'Reserved #75',                                                                                          // 75
	'Reserved #76',                                                                                          // 76
	'Reserved #77',                                                                                          // 77
	'Reserved #78',                                                                                          // 78
	'Reserved #79',                                                                                          // 79
	'TGrdLoadableCodeData structure exceeds space reserved for determinant in item descriptor',              // 80
	'Incorrect RAM area specified in loadable code descriptor',                                              // 81
	'Incorrect FLASH memory area specified in loadable code descriptor',                                     // 82
	'Allocation of intersecting FLASH memory areas for different loadable code modules',                     // 83
	'BMAP file is too long',                                                                                 // 84
	'The loadable code has zero length',                                                                     // 85
	'Data verification failed',                                                                              // 86
	'Error in Guardant Code protocol',                                                                       // 87
	'Loadable code not found',                                                                               // 88
	'IO buffer size specified in loadable code is not enough for transmitting/receiving data',               // 89
	'Security violation in Guardant Code virtual environment',                                               // 90
	'IO buffer specified in loadable code exceeds the bounds of allowed RAM area',                           // 91
	'Loadable code exceeds the bounds of allowed FLASH memory area',                                         // 92
	'Allocation of intersecting RAM areas for different loadable code modules (Init operation is required)', // 93
	'Incorrect GCEXE file format',                                                                           // 94
	'Incorrect RAM area specified in loadable code for GcaCodeRun',                                          // 95
	'Too many nested calls of GcaCodeRun',
  'Unable to create ini file during network API initialization',                                                                   // 96
	'Unknown error #'                                                                                        // 97 (all errors >= GrdE_LastError )
)
;

implementation

{ EGrdExeption }

constructor EGrdExeption.Create(AErrCode: Integer);
begin
  FErrCode:= AErrCode;
  inherited Create(aszGrdErrorRus[AErrCode]);
end;

constructor EDescriptorException.Create(AErrCode: LongWord);
begin
  FErrCode:= AErrCode;
  if FErrCode > High(DescriptorErrorRus) then
    inherited Create('Unknown Error: ' + IntToStr(AErrCode))
  else
    inherited Create(DescriptorErrorRus[AErrCode]);
end;

end.
