{------------------------------------------------------------------------------}
{        (C) 1997 - 2014 Aktiv Co. All rights reserved.                        }
{ Write mask example using Guardant API Borland Delphi  (32-64 bit)            }
{------------------------------------------------------------------------------}
{ This example demonstrates Guardant API usage for writing dongles.            }
{         This code sample is for API demonstration only!                      }
{          Please do not use this code in real projects!                       }
{------------------------------------------------------------------------------}
{$REGION 'Documentation'}
/// <summary>
///   <para>
///              
///       .
///     rev. 2015.04.14
///   </para>
/// </summary>
{$ENDREGION}
unit grdMaskManager;

interface

uses System.Classes, System.SysUtils, System.DateUtils,
      grdAbstractDescriptor, grdDescriptorStealthIILms, grdDescriptorStealthIIILms,
      grdDescriptorLMS, grdDescriptorLoadableCode, GrdStructures,
      GrdError, grddelphi;

type
  {$REGION 'Documentation'}
  /// <summary>
  ///     TAlgoItem.
  /// </summary>
  {$ENDREGION}
  PAlgoItem= ^TAlgoItem;
  {$REGION 'Documentation'}
  /// <summary>
  ///           .
  /// </summary>
  {$ENDREGION}
  TAlgoItem = record
    {$REGION 'Documentation'}
    /// <summary>
    ///     .
    /// </summary>
    {$ENDREGION}
    NumName:    Word;
    {$REGION 'Documentation'}
    /// <summary>
    ///    .
    /// </summary>
    {$ENDREGION}
    Descriptor: TAbstractDescriptor;
    {$REGION 'Documentation'}
    /// <summary>
    ///     .
    /// </summary>
    {$ENDREGION}
    Dump:       TDump;
    {$REGION 'Documentation'}
    /// <summary>
    ///     .
    /// </summary>
    {$ENDREGION}
    DumpSize:   Integer;
  end;

  {$REGION 'Documentation'}
  /// <summary>
  ///            
  ///     .
  /// </summary>
  /// <example>
  ///   <note type="delphi">
  ///     <c>Mask:= TMask.Create(dmSignTime);</c><br /><c>
  ///     Mask.ProgramNumber:= 0;</c><br /><c>Mask.Version:= 1;</c><br /><c>
  ///     Mask.SerialNumber:= 0;</c><br /><c>Mask.BitMask:= 0;</c><br /><c>
  ///     Mask.GpCounter:= 0;</c><br /><c>Mask.RealNetRes:= 5;</c><br /><c>
  ///     Mask.ProtectTime:= True;</c><br /><c>Mask.AddAlgorithm(0, GsII64);</c><br /><c>
  ///     Mask.AddLms(1, Lms);</c><br /><c>Mask.AccessCodes:= DemoCodes;</c><br /><c>
  ///     Mask.WriteDondle($F00E456A);</c>
  ///   </note>
  /// </example>
  {$ENDREGION}
  TMaskManager = class(TObject)
  private
    //   
    {$REGION 'Documentation'}
    /// <summary>
    ///     .  .
    /// </summary>
    {$ENDREGION}
    FkmNProg:       Byte;     //  .
    {$REGION 'Documentation'}
    /// <summary>
    ///     . . .
    /// </summary>
    {$ENDREGION}
    FkmVer:         Byte;     // .
    {$REGION 'Documentation'}
    /// <summary>
    ///     .  .
    /// </summary>
    {$ENDREGION}
    FkmSN:          Word;     //  .
    {$REGION 'Documentation'}
    /// <summary>
    ///     .  .
    /// </summary>
    {$ENDREGION}
    FkmMask:        Word;     //  .
    {$REGION 'Documentation'}
    /// <summary>
    ///     .    GP ( #1).
    /// </summary>
    {$ENDREGION}
    FkmGP:          Word;     //    GP ( #1).
    {$REGION 'Documentation'}
    /// <summary>
    ///     .     Guardant Net
    ///   ( #2).
    /// </summary>
    {$ENDREGION}
    FkmRealLANRes:  Word;     //     Guardant Net ( #2).
    {$REGION 'Documentation'}
    /// <summary>
    ///     .    .
    /// </summary>
    {$ENDREGION}
    FkmIndex:       LongWord; //    .

    //  
    {$REGION 'Documentation'}
    /// <summary>
    ///    ,   .
    /// </summary>
    {$ENDREGION}
    FDescriptorType:  TDescriptorType;  //  ,   
    {$REGION 'Documentation'}
    /// <summary>
    ///    ,    .
    /// </summary>
    {$ENDREGION}
    FDongleModel:     TDongleModel;     //  ,    .
    {$REGION 'Documentation'}
    /// <summary>
    ///       .
    /// </summary>
    {$ENDREGION}
    FAlgoList:        TList;            //     
    {$REGION 'Documentation'}
    /// <summary>
    ///      .
    /// </summary>
    {$ENDREGION}
    FMaskBuffer:      array of Byte;    //    
    // GS2 LMS
    {$REGION 'Documentation'}
    /// <summary>
    ///    LMS   Stealth II.
    /// </summary>
    {$ENDREGION}
    FGS2Lms: TDescriptorStealth2LMS;     //  LMS   Stealth II
    // Guardant API
    {$REGION 'Documentation'}
    /// <summary>
    ///   Guardant API.  API.
    /// </summary>
    {$ENDREGION}
    FhGrd:      TGrdHandle;     //  API
    {$REGION 'Documentation'}
    /// <summary>
    ///   Guardant API. ,     ID 
    ///   .
    /// </summary>
    {$ENDREGION}
    FDongleID:  LongWord;       // ,     ID  
    {$REGION 'Documentation'}
    /// <summary>
    ///   Guardant API.   TGrdFindInfo,    
    ///       .
    /// </summary>
    {$ENDREGION}
    FFindInfo:  TGrdFindInfo;   //   TGrdFindInfo,         
    {$REGION 'Documentation'}
    /// <summary>
    ///      .
    /// </summary>
    {$ENDREGION}
    FCodes:     TAccessCodes;   //  
    // GrdTruSetKey
    {$REGION 'Documentation'}
    /// <summary>
    ///   Guardant API.     GSII64  TRU
    ///    Sign  . <br />
    /// </summary>
    {$ENDREGION}
    FGSII64_Key128: array[0..15] of Byte; //     GSII64  TRU  Sign  
    // GrdWrite GrdProtect
    {$REGION 'Documentation'}
    /// <summary>
    ///   Guardant API.      .
    /// </summary>
    {$ENDREGION}
    FdwAddr:        LongWord;   //      
    {$REGION 'Documentation'}
    /// <summary>
    ///   Guardant API.   .
    /// </summary>
    {$ENDREGION}
    FdwLng:         LongWord;   //   
    {$REGION 'Documentation'}
    /// <summary>
    ///   Guardant API.  ,    
    ///   (@FMaskBuffer[0]).
    /// </summary>
    {$ENDREGION}
    FpData:         Pointer;    //  ,    
    {$REGION 'Documentation'}
    /// <summary>
    ///   Guardant API. SAM-  ,    (
    ///   ).
    /// </summary>
    {$ENDREGION}
    FdwWrProt:      LongWord;   // SAM-  ,    ( )
    {$REGION 'Documentation'}
    /// <summary>
    ///   Guardant API. SAM-  ,    (
    ///   ).
    /// </summary>
    {$ENDREGION}
    FdwRdProt:      LongWord;   // SAM-  ,    ( )
    {$REGION 'Documentation'}
    /// <summary>
    ///   Guardant API.      .
    /// </summary>
    {$ENDREGION}
    FdwNumFunc:     LongWord;   //      
    {$REGION 'Documentation'}
    /// <summary>
    ///   Guardant API.   ,    
    ///   .
    /// </summary>
    {$ENDREGION}
    FdwTableLMS:    LongWord;   //   ,     
    {$REGION 'Documentation'}
    /// <summary>
    ///   Guardant API.  .   Sign  .
    /// </summary>
    {$ENDREGION}
    FdwGlobalFlags: LongWord;   //  .   Sign  

    {$REGION 'Documentation'}
    /// <summary>
    ///         ID, 
    ///      .
    /// </summary>
    {$ENDREGION}
    procedure Initialilze(ADongleID: UInt64);
    {$REGION 'Documentation'}
    /// <summary>
    ///       .
    /// </summary>
    {$ENDREGION}
    procedure WriteDongle;
    {$REGION 'Documentation'}
    /// <summary>
    ///          
    ///   FHeadBuffer[]  .
    /// </summary>
    {$ENDREGION}
    procedure CreateHeader;
    {$REGION 'Documentation'}
    /// <summary>
    ///        FItemsBuffer 
    ///    .
    /// </summary>
    {$ENDREGION}
    procedure CreateItemsBuffer;
    {$REGION 'Documentation'}
    /// <summary>
    ///          
    ///   Stealth II     FAstBuffer.
    /// </summary>
    {$ENDREGION}
    procedure GS2CreateAST;
    {$REGION 'Documentation'}
    /// <summary>
    ///       ,   
    ///   FMaskBuffer[],     
    ///   GrdWrite, GrdProtect   Stealth II.
    /// </summary>
    {$ENDREGION}
    procedure GS2CreateBuffer;
    {$REGION 'Documentation'}
    /// <summary>
    ///          
    ///   Stealth III     FAstBuffer.
    /// </summary>
    {$ENDREGION}
    procedure GS3CreateAST;
    {$REGION 'Documentation'}
    /// <summary>
    ///       ,   
    ///   FMaskBuffer[],     
    ///   GrdWrite, GrdProtect   Stealth III.
    /// </summary>
    {$ENDREGION}
    procedure GS3CreateBuffer;
    {$REGION 'Documentation'}
    /// <summary>
    ///          
    ///   Sing/Time/Code/SP     FAstBuffer.
    /// </summary>
    {$ENDREGION}
    procedure GS3SCreateAST;
    {$REGION 'Documentation'}
    /// <summary>
    ///       ,   
    ///   FMaskBuffer[],     
    ///   GrdWrite, GrdProtect   Sing/Time/Code/SP.
    /// </summary>
    {$ENDREGION}
    procedure GS3SCreateBuffer;
    //  
    {$REGION 'Documentation'}
    /// <summary>
    ///       OneSessKeyProt.
    /// </summary>
    {$ENDREGION}
    function Get_GrdGF_2ndSessKey: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       HID.
    /// </summary>
    {$ENDREGION}
    function Get_GrdGF_HID: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       OneSessKeyAPI.
    /// </summary>
    {$ENDREGION}
    function Get_GrdGF_OnlyOneSessKey: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       ProtectTime.
    /// </summary>
    {$ENDREGION}
    function Get_GrdGF_ProtectTime: Boolean;
    {$REGION 'Documentation'}
    /// <summary>
    ///       OneSessKeyProt.
    /// </summary>
    {$ENDREGION}
    procedure Set_GrdGF_2ndSessKey(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///       HID.
    /// </summary>
    {$ENDREGION}
    procedure Set_GrdGF_HID(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///       OneSessKeyAPI.
    /// </summary>
    {$ENDREGION}
    procedure Set_GrdGF_OnlyOneSessKey(const Value: Boolean);
    {$REGION 'Documentation'}
    /// <summary>
    ///       ProtectTime.
    /// </summary>
    {$ENDREGION}
    procedure Set_GrdGF_ProtectTime(const Value: Boolean);
  public
    // Constructio Destructor
    {$REGION 'Documentation'}
    /// <summary>
    ///   .      
    ///   (  <see cref="GrdStructures.TDongleModel">
    ///   TDongleModel</see>).
    /// </summary>
    {$ENDREGION}
    constructor Create(DongleModel: TDongleModel);
    destructor Destroy; override;
    // properties
    {$REGION 'Documentation'}
    /// <summary>
    ///    " " -   
    ///     ( kmNProg).
    /// </summary>
    /// <value>
    ///   0  255.    = 0.
    /// </value>
    /// <seealso cref="">
    ///   http://developer.guardant.ru/pages/viewpage.action?pageId=1278706
    /// </seealso>
    {$ENDREGION}
    property ProgramNumber:  Byte read FkmNProg write FkmNProg;
    {$REGION 'Documentation'}
    /// <summary>
    ///    " " -    
    ///     ( kmVer). <br />
    /// </summary>
    /// <value>
    ///   0  255.    = 1.
    /// </value>
    {$ENDREGION}
    property Version:   Byte read FkmVer write FkmVer;
    {$REGION 'Documentation'}
    /// <summary>
    ///    " " -    
    ///     (kmSN).
    /// </summary>
    /// <value>
    ///   0  65535.    = 0.
    /// </value>
    {$ENDREGION}
    property SerialNumber:    Word read FkmSN write FkmSN;
    {$REGION 'Documentation'}
    /// <summary>
    ///    " " -    kmMask.
    /// </summary>
    /// <value>
    ///   0  65535.    = 0.
    /// </value>
    {$ENDREGION}
    property BitMask:  Word read FkmMask write FkmMask;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "  " (GP,  #1) - 
    ///          (
    ///   kmGP).
    /// </summary>
    /// <value>
    ///   0  65535.    = 0.
    /// </value>
    /// <remarks>
    ///    ,    Guardant Stealth II.
    /// </remarks>
    {$ENDREGION}
    property GpCounter:    Word read FkmGP write FkmGP;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "    " ( #2) -
    ///         
    ///   ( kmRealLANRes).
    /// </summary>
    /// <value>
    ///   0 - 65535.    = 0.
    /// </value>
    /// <remarks>
    ///     Net II.     
    ///    RealNetRes  .
    /// </remarks>
    {$ENDREGION}
    property RealNetRes: Word read FkmRealLANRes write FkmRealLANRes;
    {$REGION 'Documentation'}
    /// <summary>
    ///    .    GrdSetTime.  
    ///     ,      
    ///     .
    /// </summary>
    /// <value>
    ///        True,  GrdProtect
    ///     GrdGF_ProtectTime = 1.
    /// </value>
    /// <remarks>
    ///       (Guardant Sign  ).  
    ///     .
    /// </remarks>
    {$ENDREGION}
    property ProtectTime: Boolean read Get_GrdGF_ProtectTime write Set_GrdGF_ProtectTime;
    {$REGION 'Documentation'}
    /// <summary>
    ///    .    HID-.
    /// </summary>
    /// <value>
    ///        True,  GrdProtect
    ///     GrdGF_HID = 2.
    /// </value>
    /// <remarks>
    ///       (Guardant Sign  ).  
    ///     .
    /// </remarks>
    {$ENDREGION}
    property HID: Boolean read Get_GrdGF_HID write Set_GrdGF_HID;
    {$REGION 'Documentation'}
    /// <summary>
    ///    .     Guardant API. 
    ///         
    ///   ,  Guardant API
    /// </summary>
    /// <value>
    ///        True,  GrdProtect
    ///     GrdGF_OnlyOneSessKey = 4.
    /// </value>
    /// <remarks>
    ///       (Guardant Sign  ).  
    ///     .
    /// </remarks>
    {$ENDREGION}
    property OneSessKeyAPI: Boolean read Get_GrdGF_OnlyOneSessKey write Set_GrdGF_OnlyOneSessKey;
    {$REGION 'Documentation'}
    /// <summary>
    ///    .     . 
    ///         
    ///   ,  .
    /// </summary>
    /// <value>
    ///        True,  GrdProtect
    ///     GrdGF_2ndSessKey = 8.
    /// </value>
    /// <remarks>
    ///       (Guardant Sign  ).  
    ///     .
    /// </remarks>
    {$ENDREGION}
    property OneSessKeyProt: Boolean read Get_GrdGF_2ndSessKey write Set_GrdGF_2ndSessKey;
    {$REGION 'Documentation'}
    /// <summary>
    ///    "   ".     
    ///      .
    /// </summary>
    /// <value>
    ///   PublicCode -  , ReadCode -  , WriteCode - 
    ///   , MasterCode -  .
    /// </value>
    /// <example>
    ///   <note type="delphi">
    ///     <para>
    ///       procedure SetCodes; <br />var AccessCodes: TAccessCodes;Mask:
    ///       TMask; <br />begin <br />AccessCodes.PublicCode:=
    ///       GrdDC_DEMONVK; <br />AccessCodes.ReadCode:= GrdDC_DEMORDO; <br />
    ///       AccessCodes.WriteCode:= GrdDC_DEMOPRF; <br />
    ///       AccessCodes.MasterCode:= GrdDC_DEMOMST;
    ///     </para>
    ///     <para>
    ///       Mask:= TMask.Create(dmSignTime);
    ///     </para>
    ///     <para>
    ///       Mask.AccessCodes:= AccessCodes; <br />end;
    ///     </para>
    ///   </note>
    /// </example>
    {$ENDREGION}
    property AccessCodes : TAccessCodes read FCodes write FCodes;
    // Methods
    {$REGION 'Documentation'}
    /// <summary>
    ///        .
    /// </summary>
    /// <param name="NumericName">
    ///     .
    /// </param>
    /// <param name="Algorithm">
    ///    -  TDescriptor,    
    ///      .
    /// </param>
    {$ENDREGION}
    procedure AddAlgorithm(NumericName: Word; Algorithm: TAbstractDescriptor);
    {$REGION 'Documentation'}
    /// <summary>
    ///       128-    
    ///   GSII64,      .
    /// </summary>
    /// <param name="AKey">
    ///     .
    /// </param>
    {$ENDREGION}
    procedure AddTruKey(AKey: array of Byte);
    {$REGION 'Documentation'}
    /// <summary>
    ///        LMS   Stealth II.
    /// </summary>
    /// <param name="LmsTable">
    ///     TGS2LMS.
    /// </param>
    {$ENDREGION}
    procedure AddLms(LmsTable: TDescriptorStealth2LMS); overload;
    {$REGION 'Documentation'}
    /// <summary>
    ///        LMS   Stealth III 
    ///   .
    /// </summary>
    /// <param name="NumericName">
    ///      LMS.
    /// </param>
    /// <param name="LmsTable">
    ///     TLMSxx.
    /// </param>
    {$ENDREGION}
    procedure AddLms(NumericName: LongWord; LmsTable: TAbstractDescriptor); overload;
    {$REGION 'Documentation'}
    /// <summary>
    ///       .
    /// </summary>
    /// <param name="ADongleID">
    ///   ID  Guardant.
    /// </param>
    /// <returns>
    ///    0   .
    /// </returns>
    {$ENDREGION}
    function WriteDondle(ADongleID: UInt64): LongWord;
    {$REGION 'Documentation'}
    /// <summary>
    ///        .
    /// </summary>
    /// <param name="Dump">
    ///     array of Byte    .
    /// </param>
    {$ENDREGION}
    procedure GetDump(var Dump: TDump);
  end;
implementation

var
  {$REGION 'Documentation'}
  /// <summary>
  ///        .
  /// </summary>
  {$ENDREGION}
  FHeadBuffer: array[0..13] of Byte;
  {$REGION 'Documentation'}
  /// <summary>
  ///      Algorithm System Table (AST)   
  ///      .
  /// </summary>
  {$ENDREGION}
  FAstBuffer:  array of Byte;
  {$REGION 'Documentation'}
  /// <summary>
  ///       ,   
  ///    .
  /// </summary>
  {$ENDREGION}
  FItemsBuffer:array of Byte;

{ TMask }

constructor TMaskManager.Create(DongleModel: TDongleModel);
begin
  //   
  FkmNProg:=  0;
  FkmVer:=    1; //  
  FkmSN:=     0;
  FkmMask:=   0;
  FkmGP:=     0;
  FkmRealLANRes:= 0;
  FkmIndex:=  0;

  //   
  FDongleModel:= DongleModel;

  //   ,   
  case DongleModel of
    dmStealth2: FDescriptorType:= dtStealthII;
    dmStealth3: FDescriptorType:= dtStealthIII;
    dmSignTime: FDescriptorType:= dtSign;
    dmCode: FDescriptorType:= dtSign;
    dmSoft: FDescriptorType:= dtSign;
  end;

  //   
  FAlgoList:= TList.Create;

  // GS2 LMS
  FGS2Lms:= nil;

  // GrdWrite GrdProtect
  FdwAddr:=         0;    //      
  FdwLng:=          0;    //   
  FpData:=          nil;  //  ,    
  FdwWrProt:=       0;    // SAM-  ,    ( )
  FdwRdProt:=       0;    // SAM-  ,    ( )
  FdwNumFunc:=      0;    //      
  FdwTableLMS:=     $FFFFFFFF; //   ,     
  FdwGlobalFlags:=  0;    // GlobalFlags
  // Guardant API
  FhGrd:=             nil;//  API
  FDongleID:=         0;  // ID  
  FCodes.PublicCode:= 0;  // Public Code
  FCodes.ReadCode:=   0;  // Read Code
  FCodes.WriteCode:=  0;  // Write Code
  FCodes.MasterCode:= 0;  // Master Code
  // TRU Key
  FillChar(FGSII64_Key128[0], 16, 0); //     GSII64  TRU
end;

destructor TMaskManager.Destroy;
var
  i: Integer;
  AlgoItem: PAlgoItem;
begin
  //    TList
  for i:= 0 to (FAlgoList.Count - 1) do
  begin
    AlgoItem:= FAlgoList.Items[i];
    //AlgoItem^.Descriptor.Free;
    Dispose(AlgoItem);
  end;

  FAlgoList.Free;
  inherited;
end;

procedure TMaskManager.AddAlgorithm(NumericName: Word; Algorithm: TAbstractDescriptor);
var
  AlgoItem: PAlgoItem;
begin
  //  
  if Algorithm = nil then
    raise EDescriptorException.Create(DscE_InvalidDescriptorPointer);
  //      
  if Algorithm.DescriptorType <> FDescriptorType then
    raise EDescriptorException.Create(DscE_InvalidDescriptorType);

  //       
  case FDongleModel of
    dmStealth2:
      case Algorithm.Algo of
        rs_algo_Stealth: ;
        rs_algo_GSII64: ;
        rs_algo_HASH64:         raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_RND64:          raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_PI:             raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_GSII64_ENCRYPT: raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_GSII64_DECRYPT: raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_ECC160:         raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_AES128:         raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_LoadableCode:   raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_SHA256:         raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_AES128Encode:   raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_AES128Decode:   raise EDescriptorException.Create(DscE_Invalid_Algorithm);
      end;
    dmStealth3:
      case Algorithm.Algo of
        rs_algo_Stealth:        raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_GSII64: ;
        rs_algo_HASH64: ;
        rs_algo_RND64: ;
        rs_algo_PI: ;
        rs_algo_GSII64_ENCRYPT: raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_GSII64_DECRYPT: raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_ECC160:         raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_AES128:         raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_LoadableCode:   raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_SHA256:         raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_AES128Encode:   raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_AES128Decode:   raise EDescriptorException.Create(DscE_Invalid_Algorithm);
      end;
    dmSignTime:
    begin
      case Algorithm.Algo of
        rs_algo_Stealth:        raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_GSII64: ;
        rs_algo_HASH64: ;
        rs_algo_RND64: ;
        rs_algo_PI: ;
        rs_algo_GSII64_ENCRYPT: ;
        rs_algo_GSII64_DECRYPT: ;
        rs_algo_ECC160: ;
        rs_algo_AES128: ;
        rs_algo_LoadableCode:   raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_SHA256: ;
        rs_algo_AES128Encode: ;
        rs_algo_AES128Decode: ;
      end;
    end;
    dmCode:
      case Algorithm.Algo of
        rs_algo_Stealth:        raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_GSII64:         raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_HASH64:         raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_RND64:          raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_PI: ;
        rs_algo_GSII64_ENCRYPT: raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_GSII64_DECRYPT: raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_ECC160: ;
        rs_algo_AES128: ;
        rs_algo_LoadableCode: ;
        rs_algo_SHA256: ;
        rs_algo_AES128Encode: ;
        rs_algo_AES128Decode: ;
      end;
    dmSoft:
      case Algorithm.Algo of
        rs_algo_Stealth:        raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_GSII64:         raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_HASH64:         raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_RND64:          raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_PI: ;
        rs_algo_GSII64_ENCRYPT: raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_GSII64_DECRYPT: raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_ECC160: ;
        rs_algo_AES128: ;
        rs_algo_LoadableCode:   raise EDescriptorException.Create(DscE_Invalid_Algorithm);
        rs_algo_SHA256: ;
        rs_algo_AES128Encode: ;
        rs_algo_AES128Decode: ;
      end;
  end;

  // 0 - 0xFF00,   
  if NumericName > $FF00 then
    raise EDescriptorException.Create(DscE_InvalidDescriptorNum);

  //     dtStealth II, dtStealth III    
  case FDescriptorType of
    dtStealthII, dtStealthIII:
    begin
      if (NumericName <> (FAlgoList.Count)) then
        raise EDescriptorException.Create(DscE_InvalidDescriptorOrder);
    end;
  end;

  //    
  New(AlgoItem);
  AlgoItem^.NumName:= NumericName;
  AlgoItem^.Descriptor:= Algorithm;
  AlgoItem^.Descriptor.GetDump(AlgoItem^.Dump);
  AlgoItem^.DumpSize:= AlgoItem^.Descriptor.Size;
  FAlgoList.Add(AlgoItem);
end;

procedure TMaskManager.AddLms(LmsTable: TDescriptorStealth2LMS);
begin
  //     Stealth II
  if FDescriptorType <> dtStealthII then
    raise EDescriptorException.Create(DscE_Lms_NotCompatible);

  //   2 
  if FGS2Lms <> nil then
    raise EDescriptorException.Create(DscE_Lms_AlreadyExists);

  FGS2Lms:= LmsTable;
end;

procedure TMaskManager.AddLms(NumericName: LongWord; LmsTable: TAbstractDescriptor);
var
  NetRes: Word;
begin
  //     TDescriptor
  case FDescriptorType of
    dtStealthII:
      raise EDescriptorException.Create(DscE_Lms_NotCompatible);
    dtStealthIII:
      NetRes:= (LmsTable as TDescriptorStealth3Lms).RealNetRes;
    dtSign:
      NetRes:= (LmsTable as TDescriptorLms).RealNetRes;
  else
    begin
      raise EDescriptorException.Create(DscE_UnknownDongle);
    end;
  end;

  //           LMS
  Self.RealNetRes:= NetRes;

  //   2 
  if FdwTableLMS <> $FFFFFFFF then
    raise EDescriptorException.Create(DscE_Lms_AlreadyExists);

  //     LMS  GrdProtect
  FdwTableLMS:= NumericName;

  //   
  AddAlgorithm(NumericName, LmsTable);
end;

procedure TMaskManager.AddTruKey(AKey: array of Byte);
var
  i: Integer;
begin
  if Length(AKey) <> 16 then
    raise EDescriptorException.Create(DscE_TruKey_InvalidLength);

  for i:= 0 to 15 do
    FGSII64_Key128[i]:= AKey[i];
end;

procedure TMaskManager.CreateHeader;
var
  MaskHeader: TMaskHeader;
begin
  //    
  MaskHeader.kmNProg:=      FkmNProg;
  MaskHeader.kmVer:=        FkmVer;
  MaskHeader.kmSN:=         FkmSN;
  MaskHeader.kmMask:=       FkmMask;
  MaskHeader.kmGP:=         FkmGP;
  MaskHeader.kmRealLANRes:= FkmRealLANRes;
  MaskHeader.kmIndex:=      FkmIndex;

  Move(MaskHeader, FHeadBuffer[0], SizeOf(TMaskHeader));
end;

procedure TMaskManager.CreateItemsBuffer;
var
  AlgoItem: PAlgoItem;
  Offset, i: Integer;
  //DescriptorDump: TDump;
begin
  //  
  SetLength(FItemsBuffer, 0);

  //    
  Offset:= 0; //   
  for i:= 0 to FAlgoList.Count - 1 do
  begin
    AlgoItem:= FAlgoList[i];
    SetLength(FItemsBuffer, Length(FItemsBuffer) + AlgoItem^.Descriptor.Size);
    Move(AlgoItem^.Dump[0], FItemsBuffer[Offset], AlgoItem^.Descriptor.Size);
    Offset:= Length(FItemsBuffer);
  end;
end;

procedure TMaskManager.GetDump(var Dump: TDump);
var
  i: Integer;
begin
  CreateHeader;           //   .     
  CreateItemsBuffer;      //  .

  case FDescriptorType of
    dtStealthII:
    begin
      GS2CreateAST;     //     Stealth II
      GS2CreateBuffer;  //     Stealth II
    end;
    dtStealthIII:
    begin
      GS3CreateAST;     //     Stealth III
      GS3CreateBuffer;  //     Stealth III
    end;
    dtSign:
    begin
      GS3SCreateAST;    //     Sign Tie Code SP
      GS3SCreateBuffer; //     Sign Tie Code SP
    end;
  else
    raise EDescriptorException.Create(DscE_UnknownDongle);
  end;
  SetLength(Dump, Length(FMaskBuffer));

  for i := Low(Dump) to High(Dump) do
    Dump[i]:= FMaskBuffer[i];
end;

function TMaskManager.Get_GrdGF_2ndSessKey: Boolean;
begin
  Result:= ((FdwGlobalFlags and GrdGF_2ndSessKey) = GrdGF_2ndSessKey);
end;

function TMaskManager.Get_GrdGF_HID: Boolean;
begin
  Result:= ((FdwGlobalFlags and GrdGF_HID) = GrdGF_HID);
end;

function TMaskManager.Get_GrdGF_OnlyOneSessKey: Boolean;
begin
  Result:= ((FdwGlobalFlags and GrdGF_OnlyOneSessKey) = GrdGF_OnlyOneSessKey);
end;

function TMaskManager.Get_GrdGF_ProtectTime: Boolean;
begin
  Result:= ((FdwGlobalFlags and GrdGF_ProtectTime) = GrdGF_ProtectTime);
end;

procedure TMaskManager.Set_GrdGF_2ndSessKey(const Value: Boolean);
begin
    //  Sign  
  if FDescriptorType <> dtSign then
    raise EDescriptorException.Create(DscE_UnableSet_GlobalFlags);

  if Value = True then
    FdwGlobalFlags:= FdwGlobalFlags or GrdGF_2ndSessKey
  else
    FdwGlobalFlags:= FdwGlobalFlags and (not GrdGF_2ndSessKey);
end;

procedure TMaskManager.Set_GrdGF_HID(const Value: Boolean);
begin
    //  Sign  
  if FDescriptorType <> dtSign then
    raise EDescriptorException.Create(DscE_UnableSet_GlobalFlags);

  if Value = True then
    FdwGlobalFlags:= FdwGlobalFlags or GrdGF_HID
  else
    FdwGlobalFlags:= FdwGlobalFlags and (not GrdGF_HID);
end;

procedure TMaskManager.Set_GrdGF_OnlyOneSessKey(const Value: Boolean);
begin
    //  Sign  
  if FDescriptorType <> dtSign then
    raise EDescriptorException.Create(DscE_UnableSet_GlobalFlags);

  if Value = True then
    FdwGlobalFlags:= FdwGlobalFlags or GrdGF_OnlyOneSessKey
  else
    FdwGlobalFlags:= FdwGlobalFlags and (not GrdGF_OnlyOneSessKey);
end;

procedure TMaskManager.Set_GrdGF_ProtectTime(const Value: Boolean);
begin
  //  Sign  
  if FDescriptorType <> dtSign then
    raise EDescriptorException.Create(DscE_UnableSet_GlobalFlags);

  if Value = True then
    FdwGlobalFlags:= FdwGlobalFlags or GrdGF_ProtectTime
  else
    FdwGlobalFlags:= FdwGlobalFlags and (not GrdGF_ProtectTime);
end;

procedure TMaskManager.GS2CreateAST;
var
  AstSize: Integer; //   AST
  //DescriptorDump: TDump;
  DescriptorAddr: Integer;
  AlgoItem: PAlgoItem;
  i: Integer;
begin
  //      Stealth II - 8 
  AstSize:= 8;
  //     
  SetLength(FAstBuffer, AstSize);
  FillChar(FAstBuffer[0], AstSize, 0);

  //   AST,    > 8.  AST   .
  // 1      .
  if FAlgoList.Count > AstSize then
  begin
    AstSize:= Length(FAstBuffer) + (FAlgoList.Count mod 2) * 2;
    SetLength(FAstBuffer, AstSize);
  end;

  if FAlgoList.Count > 0 then
  begin
    //   #0
    DescriptorAddr:= (SAM_SYSTEM_LENGTH + PUBLIC_FIELDS_LENGTH + AstSize);
    FAstBuffer[0]:= DescriptorAddr div 2; //   ( )

    //       
    for i:= 0 to FAlgoList.Count - 1 do
    begin
      AlgoItem:= FAlgoList[i];  //  
      {AlgoItem^.Descriptor.GetDump(DescriptorDump);}

      //   
      DescriptorAddr:= DescriptorAddr + AlgoItem^.Descriptor.Size;

      //     Stealth II - 216 .  .
      if (DescriptorAddr > (SII_SAM_LAST_ADDRESS -1)) then
        raise EDescriptorException.Create(DscE_NotEnoughRam);

      if i < FAlgoList.Count - 1 then
        FAstBuffer[i+1]:= DescriptorAddr div 2; //  
    end;
  end;
end;

procedure TMaskManager.GS2CreateBuffer;
var
  Offset: Integer;
  LmsAddress: LongWord;
begin
  Offset:= 0;
  LmsAddress:= Offset;
  //  
  SetLength(FMaskBuffer, 0);

  //    
  SetLength(FMaskBuffer, Length(FHeadBuffer));
  Move(FHeadBuffer[0], FMaskBuffer[Offset], Length(FHeadBuffer));

  //   
  Offset:= Length(FHeadBuffer);
  SetLength(FMaskBuffer, Offset + Length(FAstBuffer));
  Move(FAstBuffer[0], FMaskBuffer[Offset], Length(FAstBuffer));

  //   
  Offset:= Length(FHeadBuffer) + Length(FAstBuffer);
  SetLength(FMaskBuffer, Offset + Length(FItemsBuffer));
  Move(FItemsBuffer[0], FMaskBuffer[Offset], Length(FItemsBuffer));

  //  LMS    Stealth 2
  //   =  
  if FGS2Lms <> nil then
  begin
    Offset:= Length(FHeadBuffer) + Length(FAstBuffer) + Length(FItemsBuffer);
    SetLength(FMaskBuffer, Offset + FGS2Lms.Size);
    Move(FGS2Lms.Dump^, FMaskBuffer[Offset], FGS2Lms.Size);
    LmsAddress:= Offset;
  end;

  FdwAddr:= SAM_SYSTEM_LENGTH;
  FdwLng:= Length(FMaskBuffer);
  FpData:= @FMaskBuffer[0];

  //     
  FdwWrProt:=   SAM_SYSTEM_LENGTH + Length(FMaskBuffer);
  //  LMS     
  FdwRdProt:=   SAM_SYSTEM_LENGTH + LmsAddress;
  FdwNumFunc:=  FAlgoList.Count;
  //  LMS 
  FdwTableLMS:= (SAM_SYSTEM_LENGTH + LMSAddress) div 2;
  FdwGlobalFlags:= 0;
end;

procedure TMaskManager.GS3CreateAST;
const
  AST_DESCR_OFFSET = 6; //    AST    
var
  AstSize:  Integer;    //    
  FreeMemAddr:   Word;  // SAM-     
  DescriptorAddr: Word; // SAM- 
  AlgoItem: PAlgoItem;  //   
  i: Integer;
begin
  //       Stealth III - 8 
  AstSize:= 8;

  //     ,  
  SetLength(FAstBuffer, AstSize);
  FillChar(FAstBuffer[0], AstSize, 0);

  //  SAM-     
  FreeMemAddr:= SAM_SYSTEM_LENGTH + PUBLIC_FIELDS_LENGTH + AstSize;

  if FAlgoList.Count > 0 then
  begin
    //   AST.      2 
    AstSize:= Length(FAstBuffer) + FAlgoList.Count * 2;
    SetLength(FAstBuffer, AstSize);

    // SAM-    #0 ( )
    DescriptorAddr:= (SAM_SYSTEM_LENGTH + PUBLIC_FIELDS_LENGTH + AstSize);
    Move(DescriptorAddr, FAstBuffer[AST_DESCR_OFFSET], SizeOf(Word));

    //       
    for i:= 0 to FAlgoList.Count - 1 do
    begin
      AlgoItem:= FAlgoList[i];
      DescriptorAddr:= DescriptorAddr + AlgoItem^.DumpSize; // SAM-  (i+1) 

      //     Stealth III - 1912 .  .
      if (DescriptorAddr  > (SIII_SAM_LAST_ADDRESS - 1)) then
        raise EDescriptorException.Create(DscE_NotEnoughRam);

      if (i = (FAlgoList.Count - 1)) then //   
        FreeMemAddr:= DescriptorAddr // SAM-        .
      else
      //    
      Move(DescriptorAddr, FAstBuffer[AST_DESCR_OFFSET + (i + 1)*2], SizeOf(Word));
    end;
  end;

  //  SAM-     
  Move(FreeMemAddr, FAstBuffer[4], SizeOf(Word));
end;

procedure TMaskManager.GS3CreateBuffer;
var
  Offset: Integer; //  
begin
  Offset:= 0;
  //  
  SetLength(FMaskBuffer, 0);

  //    
  SetLength(FMaskBuffer, Length(FHeadBuffer));
  Move(FHeadBuffer[0], FMaskBuffer[Offset], Length(FHeadBuffer));

  //   
  Offset:= Length(FHeadBuffer);
  SetLength(FMaskBuffer, Offset + Length(FAstBuffer));
  Move(FAstBuffer[0], FMaskBuffer[Offset], Length(FAstBuffer));

  //   
  Offset:= Length(FHeadBuffer) + Length(FAstBuffer);
  SetLength(FMaskBuffer, Offset + Length(FItemsBuffer));
  Move(FItemsBuffer[0], FMaskBuffer[Offset], Length(FItemsBuffer));

  //   Write Protect
  FdwAddr:= SAM_SYSTEM_LENGTH;
  FdwLng:= Length(FMaskBuffer);
  FpData:= @FMaskBuffer[0];

  //       
  FdwWrProt:=   SAM_SYSTEM_LENGTH + Length(FMaskBuffer);
  FdwRdProt:=   SAM_SYSTEM_LENGTH + Length(FMaskBuffer);
  FdwNumFunc:=  FAlgoList.Count;
  //FdwTableLMS:= ;      
end;

procedure TMaskManager.GS3SCreateAST;
var
  PIMTBuffer: array [0..17] of Byte;  // Protected Item Main Table (PIMT)    
  PIRTBuffer: array of Word;          // Protected Item Root Table (PIRT)       
  PIATBuffer: array of Word;          // Protected Item Allocation Table (PIAT)     /

  PIRTAddr, PIATAddr:  Word;  //   PIRT, PIAT
  FreeMemAddr:   Word;        // SAM-     
  DescriptorAddr: Word;       // SAM- 
  AlgoItem: PAlgoItem;        //   
  i: Integer;
begin
  //   PIRT
  SetLength(PIRTBuffer, FAlgoList.Count);
  for i:= 0 to FAlgoList.Count - 1 do
  begin
    AlgoItem:= FAlgoList[i]; //  
    PIRTBuffer[i]:= AlgoItem^.NumName;
  end;

  // SAM-  PIRT     PIMT 18 
  PIRTAddr:= SAM_SYSTEM_LENGTH + PUBLIC_FIELDS_LENGTH + 18;

  // SAM-  PIAT
  PIATAddr:= PIRTAddr + Length(PIRTBuffer)*sizeof(Word);

  //   PIAT
  SetLength(PIATBuffer, FAlgoList.Count); //    8 

  // SAM-      ,   ,  AST   8 
  DescriptorAddr:= SAM_SYSTEM_LENGTH + PUBLIC_FIELDS_LENGTH + (18 + FAlgoList.Count*4 + 8);

  //  SAM-    PIAT
  PIATBuffer[0]:= DescriptorAddr;

  for i:= 0 to FAlgoList.Count - 1 do
  begin
    AlgoItem:= FAlgoList[i];  //  ,   0
    {AlgoItem^.Descriptor.GetDump(DescriptorDump);}

    DescriptorAddr:= DescriptorAddr + AlgoItem^.DumpSize; // SAM-  (i+1) 

    //     Sign - 3930 .  .
    if (DescriptorAddr  > (SIGN_SAM_LAST_ADDRESS - 1)) then
      raise EDescriptorException.Create(DscE_NotEnoughRam);

    if (i = (FAlgoList.Count - 1)) then //   
      FreeMemAddr:= DescriptorAddr // SAM-        .
    else
      PIATBuffer[i+1]:= DescriptorAddr; //  SAM-    PIAT
  end;

  //   PIMT
  FillChar(PIMTBuffer[0], 18, 0);       //  
  PIMTBuffer[1]:= 1;                    //     : 1   Guardant Sign/Time/Code.
  Move(FreeMemAddr, PIMTBuffer[2], 2);  // SAM-        .
  Move(PIATAddr, PIMTBuffer[4], 2);     // SAM-    PIAT.
  Move(PIRTAddr, PIMTBuffer[16], 2);    // SAM-    PIRT.

  //   AST
  SetLength(FAstBuffer, 18 + FAlgoList.Count*4 + 8);
  Move(PIMTBuffer[0], FAstBuffer[0],  Length(PIMTBuffer)*sizeof(Word));
  Move(PIRTBuffer[0], FAstBuffer[18], Length(PIRTBuffer)*sizeof(Word));
  Move(PIATBuffer[0], FAstBuffer[18+Length(PIRTBuffer)*sizeof(Word)], Length(PIATBuffer)*sizeof(Word));
end;

procedure TMaskManager.GS3SCreateBuffer;
var
  Offset: Integer; //  
begin
  Offset:= 0;
  //  
  SetLength(FMaskBuffer, 0);

  //    
  SetLength(FMaskBuffer, Length(FHeadBuffer));
  Move(FHeadBuffer[0], FMaskBuffer[Offset], Length(FHeadBuffer));

  //   
  Offset:= Length(FHeadBuffer);
  SetLength(FMaskBuffer, Offset + Length(FAstBuffer));
  Move(FAstBuffer[0], FMaskBuffer[Offset], Length(FAstBuffer));

  //   
  Offset:= Length(FHeadBuffer) + Length(FAstBuffer);
  SetLength(FMaskBuffer, Offset + Length(FItemsBuffer));
  Move(FItemsBuffer[0], FMaskBuffer[Offset], Length(FItemsBuffer));

  //   Write Protect
  FdwAddr:= SAM_SYSTEM_LENGTH;
  FdwLng:= Length(FMaskBuffer);
  FpData:= @FMaskBuffer[0];
  //       
  FdwWrProt:=   SAM_SYSTEM_LENGTH + Length(FMaskBuffer);
  FdwRdProt:=   SAM_SYSTEM_LENGTH + Length(FMaskBuffer);
  FdwNumFunc:=  FAlgoList.Count;
  //FdwTableLMS:= ;      
end;

function TMaskManager.WriteDondle(ADongleID: UInt64): LongWord;
begin
  Initialilze(ADongleID); //  API,   

  CreateHeader();           //   .     
  CreateItemsBuffer();      //  .

  case FDescriptorType of
    dtStealthII:
    begin
      GS2CreateAST();     //     Stealth II
      GS2CreateBuffer();  //     Stealth II
    end;
    dtStealthIII:
    begin
      GS3CreateAST();     //     Stealth III
      GS3CreateBuffer();  //     Stealth III
    end;
    dtSign:
    begin
      GS3SCreateAST();    //     Sign Tie Code SP
      GS3SCreateBuffer(); //     Sign Tie Code SP
    end;
  else
    raise EDescriptorException.Create(DscE_UnknownDongle);
  end;

  WriteDongle(); //     ,  gcexe,  
  Result:= 0;
end;

procedure TMaskManager.Initialilze(ADongleID: UInt64);
var
  nRet: Integer;
  FoundDescriptorType: TDescriptorType;
begin
  nRet:= GrdStartup(GrdFMR_Local);
  if nRet <> 0 then
    raise EGrdExeption.Create(nRet);

  FhGrd:= GrdCreateHandle(nil, GrdCHM_MultiThread, nil);
  if (GrdIsValidHandle(FhGrd) = 0) then
  begin
    GrdCleanup();
    raise EGrdExeption.Create(GrdE_InvalidHandle);
  end;

  nRet:= GrdSetFindMode(FhGrd, GrdFMR_Local, GrdFM_ID, 0, ADongleID, 0, 0, 0, GrdDT_Win, GrdFMM_ALL, GrdFMI_ALL);
  if nRet <> 0 then
  begin
    GrdCloseHandle(FhGrd);
    GrdCleanup();
    raise EGrdExeption.Create(nRet);
  end;

  nRet:= GrdFind(FhGrd, GrdF_First, @FDongleID, @FFindInfo);
  if nRet <> 0 then
  begin
    GrdCloseHandle(FhGrd);
    GrdCleanup();
    raise EGrdExeption.Create(nRet);
  end;

  //   ,    
  case FFindInfo.wType of
    //0:    FoundDongleType:= dtUnknown;      // Stealth ( )
    //7:    FoundDongleType:= dtUnknown;      // Net ( )
    10:   FoundDescriptorType:= dtStealthII;      // Stealth 2
    15:   FoundDescriptorType:= dtStealthII;      // NET 2
    58:   FoundDescriptorType:= dtStealthIII;     // Stealth 3
    63:   FoundDescriptorType:= dtStealthIII;     // NET 3
    442:  FoundDescriptorType:= dtSign;     // Sign
    447:  FoundDescriptorType:= dtSign;     // Sign Net
    504:  FoundDescriptorType:= dtSign;     // Time
    509:  FoundDescriptorType:= dtSign;     // Time Net
    1458: FoundDescriptorType:= dtSign;     // Code
    1520: FoundDescriptorType:= dtSign;     // Code Time
    466:  FoundDescriptorType:= dtSign;     // SP
    467:  FoundDescriptorType:= dtSign;     // SP Net
  else
    GrdCloseHandle(FhGrd);
    GrdCleanup();
    raise EDescriptorException.Create(DscE_UnknownDongle);
  end;

  //   ID     
  if FDescriptorType <> FoundDescriptorType then
  begin
    GrdCloseHandle(FhGrd);
    GrdCleanup();
    raise EDescriptorException.Create(DscE_InvalidDongleType);
  end;
  //   
  if FFindInfo.dwPublicCode <> FCodes.PublicCode then
  begin
    GrdCloseHandle(FhGrd);
    GrdCleanup();
    raise EDescriptorException.Create(DscE_InvalidPublicCodes);
  end;
end;

procedure TMaskManager.WriteDongle;
var
  nRet, i: Integer;
  AlgoItem: PAlgoItem;
  LoadableCodeDump: TDump;
  LoadableCodeName: Word;
  LoadableCodeSize: Integer;
  SysTime: TGrdSystemTime;
  tNow: TDateTime;
begin
  nRet:= GrdSetAccessCodes(FhGrd, FCodes.PublicCode, FCodes.ReadCode, FCodes.WriteCode, FCodes.MasterCode);
  if nRet <> 0 then
  begin
    GrdCloseHandle(FhGrd);
    GrdCleanup();
    raise EGrdExeption.Create(nRet);
  end;

  nRet:= GrdSetWorkMode(FhGrd, GrdWM_SAM, GrdWMFM_DriverAuto);
  if nRet <> 0 then
  begin
    GrdCloseHandle(FhGrd);
    GrdCleanup();
    raise EGrdExeption.Create(nRet);
  end;

  nRet:= GrdLogin(FhGrd, $FFFFFFFF, GrdLM_PerStation);
  if nRet <> 0 then
  begin
    GrdCloseHandle(FhGrd);
    GrdCleanup();
    raise EGrdExeption.Create(nRet);
  end;

  if ((FDongleModel = dmSignTime) or (FDongleModel = dmCode)) then
  begin
    nRet:= GrdTRU_SetKey(FhGrd, @FGSII64_Key128[0]);
    if nRet <> 0 then
    begin
      GrdLogout(FhGrd, 0);
      GrdCloseHandle(FhGrd);
      GrdCleanup();
      raise EGrdExeption.Create(nRet);
    end;
  end
  else
  begin
    nRet:= GrdInit(FhGrd);
    if nRet <> 0 then
    begin
      GrdLogout(FhGrd, 0);
      GrdCloseHandle(FhGrd);
      GrdCleanup();
      raise EGrdExeption.Create(nRet);
    end;
  end;

  //   
  case FFindInfo.wType of
    504, 509, 1520: // Time, Time Net,  Code Time
    begin
      tNow:= Now;
      SysTime.wYear:= YearOf(tNow);
      SysTime.wMonth:= MonthOf(tNow);
      SysTime.wDayOfWeek:= DayOfTheWeek(tNow);
      SysTime.wDay:= DayOfTheMonth(tNow);
      SysTime.wHour:= HourOf(tNow);
      SysTime.wMinute:= MinuteOf(tNow);
      SysTime.wSecond:= SecondOf(tNow);
      SysTime.wMilliseconds:= MilliSecondOf(tNow);
      nRet:= GrdSetTime(FhGrd, @SysTime, nil);
      if nRet <> 0 then
      begin
        GrdLogout(FhGrd, 0);
        GrdCloseHandle(FhGrd);
        GrdCleanup();
        raise EGrdExeption.Create(nRet);
      end;
    end;
  end;

  nRet:= GrdWrite(FhGrd, FdwAddr, FdwLng, FpData, nil);
  if nRet <> 0 then
  begin
    GrdLogout(FhGrd, 0);
    GrdCloseHandle(FhGrd);
    GrdCleanup();
    raise EGrdExeption.Create(nRet);
  end;

  nRet:= GrdProtect(FhGrd, FdwWrProt, FdwRdProt, FdwNumFunc, FdwTableLMS, FdwGlobalFlags, nil);
  if nRet <> 0 then
  begin
    GrdLogout(FhGrd, 0);
    GrdCloseHandle(FhGrd);
    GrdCleanup();
    raise EGrdExeption.Create(nRet);
  end;

  //     
  case FFindInfo.wType of
    1458, 1520: //  Code  Code Time
    begin
      for i:= 0 to FAlgoList.Count - 1 do
      begin
        AlgoItem:= FAlgoList[i]; //  
        if (AlgoItem^.Descriptor is TDescriptorLoadableCode) then
        begin
          (AlgoItem^.Descriptor as TDescriptorLoadableCode).GetLoadableCodeDump(LoadableCodeDump);
          LoadableCodeName:= AlgoItem^.NumName;
          LoadableCodeSize:= Length(LoadableCodeDump);
          nRet:= GrdCodeLoad(FhGrd, LoadableCodeName, LoadableCodeSize, @LoadableCodeDump[0], nil);
          if nRet <> 0 then
          begin
            GrdCloseHandle(FhGrd);
            GrdCleanup();
            raise EGrdExeption.Create(nRet);
          end;
        end;
      end;
    end;
  end;

  nRet:= GrdLogout(FhGrd, 0);
  if nRet <> 0 then
  begin
    GrdCloseHandle(FhGrd);
    GrdCleanup();
    raise EGrdExeption.Create(nRet);
  end;

  nRet:= GrdCloseHandle(FhGrd);
  if nRet <> 0 then
  begin
    GrdCleanup();
    raise EGrdExeption.Create(nRet);
  end;

  GrdCleanup();
end;

end.
